import { APIRequest } from "../utils/APIRequest";
import { RequestOpts } from '../typings';
import { IUserConnection } from '../typings/api/connections';
/**
 * @api public
 * ConnectionsAPI - Provides methods to interact with the Connections API
 */
declare class ConnectionsAPI extends APIRequest {
    constructor(opts: RequestOpts);
    /**
     * `POST /api/connections/connect/` - Promises to connect to a user
     * @param {IUserConnection} opts
     */
    connect(opts: IUserConnection): Promise<any>;
    /**
     * `POST /api/connections/confirm/` - Promises to confirm a user connection
     * @param {IUserConnection} opts
     */
    confirm(opts: IUserConnection): Promise<any>;
    /**
     * `POST /api/connections/update/` - Promises to update a connection
     * @param {IUserConnection} opts
     */
    update(opts: IUserConnection): Promise<any>;
    /**
     * `POST /api/connections/disconnect/` - Promises to disconnect from a user
     * @param {string} username - The user to disconnect from
     */
    disconnect(username: string): Promise<any>;
}
export { ConnectionsAPI };
