import { APIRequest } from "../utils/APIRequest";
import { RequestOpts } from '../typings';
import { IUserFollows } from '../typings/api/follows';
/**
 * @api public
 * FollowsAPI - Provides methods to interact with the Follows API
 */
declare class FollowsAPI extends APIRequest {
    constructor(opts: RequestOpts);
    /**
     * `POST /api/follows/follow/` - Promises to follow a user
     * @param {IUserFollows} opts
     */
    follow(opts: IUserFollows): Promise<any>;
    /**
     * `POST /api/follows/update/` - Promises to update a following
     * @param {IUserFollows} opts
     */
    update(opts: IUserFollows): Promise<any>;
    /**
     * `POST /api/follows/unfollow/` - Promises to unfollow a user
     * @param {string} username - The username of the user to unfollow
     */
    unfollow(username: string): Promise<any>;
}
export { FollowsAPI };
