"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var APIRequest_1 = require("../utils/APIRequest");
/**
 * @api public
 * FollowsAPI - Provides methods to interact with the Follows API
 */
var FollowsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(FollowsAPI, _super);
    function FollowsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `POST /api/follows/follow/` - Promises to follow a user
     * @param {IUserFollows} opts
     */
    FollowsAPI.prototype.follow = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('follow');
                body = {
                    username: opts.username
                };
                if (opts.listIds && opts.listIds.length) {
                    body.lists_ids = opts.listIds;
                }
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/follows/update/` - Promises to update a following
     * @param {IUserFollows} opts
     */
    FollowsAPI.prototype.update = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('update');
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/follows/unfollow/` - Promises to unfollow a user
     * @param {string} username - The username of the user to unfollow
     */
    FollowsAPI.prototype.unfollow = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('unfollow');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    return FollowsAPI;
}(APIRequest_1.APIRequest));
exports.FollowsAPI = FollowsAPI;
