import { APIRequest } from "../utils/APIRequest";
import { RequestOpts, LimitationParams } from '../typings';
import { IGetGlobalModeratedObjects, IModeratedObject, IUpdateModeratedObject } from '../typings/api/moderation';
declare class ModerationAPI extends APIRequest {
    constructor(opts: RequestOpts);
    getGlobalModeratedObjects(opts: IGetGlobalModeratedObjects): Promise<any>;
    getModeratedObjectLogs(opts: IModeratedObject): Promise<any>;
    getModeratedObjectReports(opts: IModeratedObject): Promise<any>;
    getModerationCategories(): Promise<any>;
    getUserModerationPenalties(opts: LimitationParams): Promise<any>;
    getUserPendingModeratedObjectsCommunities(opts: LimitationParams): Promise<any>;
    verifyModeratedObject(id: number): Promise<any>;
    unverifyModeratedObject(id: number): Promise<any>;
    approveModeratedObject(id: number): Promise<any>;
    rejectModeratedObject(id: number): Promise<any>;
    updateModeratedObject(id: number, opts: IUpdateModeratedObject): Promise<any>;
}
export { ModerationAPI };
