"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var APIRequest_1 = require("../utils/APIRequest");
var ModerationAPI = /** @class */ (function (_super) {
    tslib_1.__extends(ModerationAPI, _super);
    function ModerationAPI(opts) {
        return _super.call(this, opts) || this;
    }
    ModerationAPI.prototype.getGlobalModeratedObjects = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', 'global');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.statuses && opts.statuses.length) {
                    this._params.statuses = opts.statuses.join(',');
                }
                if (opts.types && opts.types.length) {
                    this._params.types = opts.types.join(',');
                }
                if (opts.verified !== undefined) {
                    this._params.verified = opts.verified;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModeratedObjectLogs = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', encodeURIComponent(opts.id), 'logs');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModeratedObjectReports = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', encodeURIComponent(opts.id), 'reports');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModerationCategories = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('categories');
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getUserModerationPenalties = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'penalties');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getUserPendingModeratedObjectsCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'pending-moderated-objects-communities');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.verifyModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'verify');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.unverifyModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'unverify');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.approveModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'approve');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.rejectModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'reject');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.updateModeratedObject = function (id, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString());
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    return ModerationAPI;
}(APIRequest_1.APIRequest));
exports.ModerationAPI = ModerationAPI;
