import { APIRequest } from '../utils/APIRequest';
import { RequestOpts, ExtraLimitationParams } from '../typings';
import { IGetTimelinePosts, ICreatePost, IEditPost, IGetReactionsForPost, IReportPost, IReportPostComment, IGetPostParticipants, ISearchPostParticipants } from '../typings/api/posts';
declare class PostsAPI extends APIRequest {
    constructor(opts: RequestOpts);
    getTimelinePosts(opts: IGetTimelinePosts): Promise<any>;
    createPost(opts: ICreatePost): Promise<any>;
    getTrendingPosts(): Promise<any>;
    editPost(opts: IEditPost): Promise<any>;
    getPostWithUuid(uuid: string): Promise<any>;
    deletePostWithUuid(uuid: string): Promise<any>;
    getCommentsForPost(uuid: string, opts: ExtraLimitationParams): Promise<any>;
    getRepliesForPostComment(postUuid: string, postCommentId: number, opts: ExtraLimitationParams): Promise<any>;
    commentOnPost(uuid: string, text: string): Promise<any>;
    editPostComment(postUuid: string, commentId: number, text: string): Promise<any>;
    replyPostComment(postUuid: string, commentId: number, text: string): Promise<any>;
    deletePostComment(postUuid: string, commentId: number): Promise<any>;
    getReactionsForPost(uuid: string, opts: IGetReactionsForPost): Promise<any>;
    getReactionsEmojiCountForPost(uuid: string): Promise<any>;
    reactToPost(uuid: string, emojiId: number): Promise<any>;
    deletePostReaction(postUuid: string, reactionId: number): Promise<any>;
    getReactionsForPostComment(postUuid: string, commentId: number, opts: IGetReactionsForPost): Promise<any>;
    getReactionsEmojiCountForPostComment(postUuid: string, commentId: number): Promise<any>;
    reactToPostComment(postUuid: string, commentId: number, emojiId: number): Promise<any>;
    deletePostCommentReaction(postUuid: string, commentId: number, reactionId: number): Promise<any>;
    mutePostComment(postUuid: string, commentId: number): Promise<any>;
    unmutePostComment(postUuid: string, commentId: number): Promise<any>;
    mutePost(uuid: string): Promise<any>;
    unmutePost(uuid: string): Promise<any>;
    disableCommentsForPost(uuid: string): Promise<any>;
    enableCommentsForPost(uuid: string): Promise<any>;
    openPost(uuid: string): Promise<any>;
    closePost(uuid: string): Promise<any>;
    getReactionEmojiGroups(): Promise<any>;
    reportPost(opts: IReportPost): Promise<any>;
    reportPostComment(opts: IReportPostComment): Promise<any>;
    translatePost(uuid: string): Promise<any>;
    translatePostComment(postUuid: string, commentId: number): Promise<any>;
    getPostParticipants(opts: IGetPostParticipants): Promise<any>;
    searchPostParticipants(opts: ISearchPostParticipants): Promise<any>;
}
export { PostsAPI };
