/**
 * buildUrl()
 * Creates a fetchable URL
 * @param {string} apiUrl - The URL address of the Okuna API server
 * @param {string[]} paths - An array containing additional paths for the endpoint
 * @param {object} params - Key-value properties to append to the URL (mainly used for GET requests)
 * @returns {string} - The final URL to fetch
 */
declare const buildUrl: (apiUrl: string, paths: string[], params: object) => string;
export default buildUrl;
