"use strict";
var tslib_1 = require("tslib");
var core_1 = tslib_1.__importDefault(require("./core"));
var es6_promise_1 = tslib_1.__importDefault(require("es6-promise"));
es6_promise_1.default.polyfill();
require("isomorphic-form-data");
require("isomorphic-fetch");
/**
 * @api
 */
var FetchStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(FetchStrategy, _super);
    function FetchStrategy() {
        return _super.call(this, 'fetch') || this;
    }
    FetchStrategy.prototype.get = function (url, opts) {
        return new Promise(function (resolve, reject) {
            return fetch(url, tslib_1.__assign({ method: 'GET' }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.post = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'POST', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.put = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'PUT', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.patch = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'PATCH', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.delete = function (url, opts) {
        return new Promise(function (resolve, reject) {
            return fetch(url, tslib_1.__assign({ method: 'DELETE' }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    return FetchStrategy;
}(core_1.default));
module.exports = FetchStrategy;
