"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = tslib_1.__importDefault(require("./core"));
exports.RequestStrategy = core_1.default;
var AxiosStrategy_1 = tslib_1.__importDefault(require("./AxiosStrategy"));
var FetchStrategy_1 = tslib_1.__importDefault(require("./FetchStrategy"));
var getRequestStrategy = function (strategy) {
    if (typeof strategy === 'function' && strategy.prototype instanceof core_1.default) {
        return new strategy();
    }
    if (strategy === 'axios') {
        return new AxiosStrategy_1.default();
    }
    if (strategy === 'fetch') {
        return new FetchStrategy_1.default();
    }
    throw new Error("Unknown request strategy: " + strategy + ".");
};
exports.getRequestStrategy = getRequestStrategy;
