(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["Okuna"] = factory();
	else
		root["Okuna"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./lib/Okuna.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./lib/Okuna.js":
/*!**********************!*\
  !*** ./lib/Okuna.js ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var requestStrategies_1 = __webpack_require__(/*! ./utils/requestStrategies */ "./lib/utils/requestStrategies/index.js");
exports.RequestStrategy = requestStrategies_1.RequestStrategy;
var auth_1 = __webpack_require__(/*! ./api/auth */ "./lib/api/auth.js");
var categories_1 = __webpack_require__(/*! ./api/categories */ "./lib/api/categories.js");
var circles_1 = __webpack_require__(/*! ./api/circles */ "./lib/api/circles.js");
var communities_1 = __webpack_require__(/*! ./api/communities */ "./lib/api/communities.js");
var connections_1 = __webpack_require__(/*! ./api/connections */ "./lib/api/connections.js");
var devices_1 = __webpack_require__(/*! ./api/devices */ "./lib/api/devices.js");
var emojis_1 = __webpack_require__(/*! ./api/emojis */ "./lib/api/emojis.js");
var follows_1 = __webpack_require__(/*! ./api/follows */ "./lib/api/follows.js");
var health_1 = __webpack_require__(/*! ./api/health */ "./lib/api/health.js");
var lists_1 = __webpack_require__(/*! ./api/lists */ "./lib/api/lists.js");
var moderation_1 = __webpack_require__(/*! ./api/moderation */ "./lib/api/moderation.js");
var notifications_1 = __webpack_require__(/*! ./api/notifications */ "./lib/api/notifications.js");
var posts_1 = __webpack_require__(/*! ./api/posts */ "./lib/api/posts.js");
var userInvites_1 = __webpack_require__(/*! ./api/userInvites */ "./lib/api/userInvites.js");
/**
 * @api public
 */
var Client = /** @class */ (function () {
    function Client(opts) {
        if (opts === void 0) { opts = {}; }
        this.apiUrl = opts.apiUrl || 'https://api.openbook.social';
        this.authToken = opts.authToken || null;
        var magicHeader = this._buildMagicHeader(opts.magicHeaderName, opts.magicHeaderValue);
        this.magicHeaderName = magicHeader.name;
        this.magicHeaderValue = magicHeader.value;
        this.requestStrategy = opts.requestStrategy || 'fetch';
    }
    /**
     * _buildMagicHeader() - Builds a magic header to add to the request headers
     * @param {string | null | undefined} name - the name of the magic header
     * @param {string | null | undefined} value - the value of the magic header
     * @returns {object} an object containing the provided data
     */
    Client.prototype._buildMagicHeader = function (name, value) {
        if (name === null || value === null) {
            return {
                name: name,
                value: value
            };
        }
        return {
            name: name || 'X-JESUS-TAKE-THE-WHEEL',
            value: value || 'jesusCantReallyDriveTho'
        };
    };
    /**
     * updateAuthToken() - Updates the authorization token of the current Client instance
     * @param {string} token - the new authorization token
     */
    Client.prototype.updateAuthToken = function (token) {
        this.authToken = token;
    };
    /**
     * auth()
     * @returns { AuthAPI } - AuthAPI instance
     */
    Client.prototype.auth = function () {
        return new auth_1.AuthAPI({ okuna: this, endpoint: '/api/auth' });
    };
    /**
     * categories()
     * @returns {CategoriesAPI} - CategoriesAPI instance
     */
    Client.prototype.categories = function () {
        return new categories_1.CategoriesAPI({ okuna: this, endpoint: '/api/categories' });
    };
    /**
     * circles()
     * @returns {CirclesAPI} - CirclesAPI instance
     */
    Client.prototype.circles = function () {
        return new circles_1.CirclesAPI({ okuna: this, endpoint: '/api/circles' });
    };
    /**
     * communities()
     * @returns {CommunitiesAPI} - CommunitiesAPI instance
     */
    Client.prototype.communities = function () {
        return new communities_1.CommunitiesAPI({ okuna: this, endpoint: '/api/communities' });
    };
    /**
     * connections()
     * @returns {ConnectionsAPI} - ConnectionsAPI instance
     */
    Client.prototype.connections = function () {
        return new connections_1.ConnectionsAPI({ okuna: this, endpoint: '/api/connections' });
    };
    /**
     * devices()
     * @returns {DevicesAPI} - DevicesAPI instance
     */
    Client.prototype.devices = function () {
        return new devices_1.DevicesAPI({ okuna: this, endpoint: '/api/devices' });
    };
    /**
     * emojis()
     * @returns {EmojisAPI} - EmojisAPI instance
     */
    Client.prototype.emojis = function () {
        return new emojis_1.EmojisAPI({ okuna: this, endpoint: '/api/emojis' });
    };
    /**
     * follows()
     * @returns {FollowsAPI} - FollowsAPI instance
     */
    Client.prototype.follows = function () {
        return new follows_1.FollowsAPI({ okuna: this, endpoint: '/api/follows' });
    };
    /**
     * health()
     * @returns {HealthAPI} - HealthAPI instance
     */
    Client.prototype.health = function () {
        return new health_1.HealthAPI({ okuna: this, endpoint: '/api/health' });
    };
    /**
     * lists()
     * @returns {ListsAPI} - ListsAPI instance
     */
    Client.prototype.lists = function () {
        return new lists_1.ListsAPI({ okuna: this, endpoint: '/api/lists' });
    };
    /**
     * moderation()
     * @returns {ModerationAPI} - ModerationAPI instance
     */
    Client.prototype.moderation = function () {
        return new moderation_1.ModerationAPI({ okuna: this, endpoint: '/api/moderation' });
    };
    /**
     * notifications()
     * @returns {NotificationsAPI} - NotificationsAPI instance
     */
    Client.prototype.notifications = function () {
        return new notifications_1.NotificationsAPI({ okuna: this, endpoint: '/api/notifications' });
    };
    /**
     * posts()
     * @returns {PostsAPI} - PostsAPI instance
     */
    Client.prototype.posts = function () {
        return new posts_1.PostsAPI({ okuna: this, endpoint: '/api/posts' });
    };
    /**
     * userInvites()
     * @returns {UserInvitesAPI} - UserInvitesAPI instance
     */
    Client.prototype.userInvites = function () {
        return new userInvites_1.UserInvitesAPI({ okuna: this, endpoint: '/api/invites' });
    };
    return Client;
}());
exports.Client = Client;


/***/ }),

/***/ "./lib/api/auth.js":
/*!*************************!*\
  !*** ./lib/api/auth.js ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
var FileObject_1 = __webpack_require__(/*! ../utils/FileObject */ "./lib/utils/FileObject.js");
/**
 * @api public
 * AuthAPI - provides methods to interact with the Auth API
 */
var AuthAPI = /** @class */ (function (_super) {
    tslib_1.__extends(AuthAPI, _super);
    function AuthAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `POST /api/auth/username-check/` - Promises to check if a username is available
     * @param {string} username - The desired username
     * @returns - a boolean
     */
    AuthAPI.prototype.isUsernameAvailable = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('username-check');
                this.requiresToken = false;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        return _this.post({ username: username })
                            .then(function () { return resolve(true); })
                            .catch(function (err) {
                            if (err.response && err.response.status === 400) {
                                return resolve(false);
                            }
                            return reject(err);
                        });
                    })];
            });
        });
    };
    /**
     * `POST /api/auth/email-check/` - Promises to check if an email address is available
     * @param {string} email - The desired email address
     * @returns - a boolean
     */
    AuthAPI.prototype.isEmailAvailable = function (email) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('email-check');
                this.requiresToken = false;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        return _this.post({ email: email })
                            .then(function () { return resolve(true); })
                            .catch(function (err) {
                            if (err.response && err.response.status === 400) {
                                return resolve(false);
                            }
                            return reject(err);
                        });
                    })];
            });
        });
    };
    /**
     * `POST /api/auth/register/` (urlencoded) - Promises to create a user
     * @param {UserCreatorOpts} payload - The user's properties
     * @returns - the created user
     */
    AuthAPI.prototype.createUser = function (payload) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var email, token, name, isOfLegalAge, areGuidelinesAccepted, password, body;
            return tslib_1.__generator(this, function (_a) {
                email = payload.email, token = payload.token, name = payload.name, isOfLegalAge = payload.isOfLegalAge, areGuidelinesAccepted = payload.areGuidelinesAccepted, password = payload.password;
                body = {
                    email: email,
                    token: token,
                    name: name,
                    is_of_legal_age: isOfLegalAge.toString(),
                    are_guidelines_accepted: areGuidelinesAccepted.toString(),
                    password: password
                };
                if (payload.avatar) {
                    body['avatar'] = new FileObject_1.FileObject(payload.avatar);
                }
                this._paths.push('register');
                this.requiresToken = false;
                return [2 /*return*/, this.postFormdata(body)];
            });
        });
    };
    /**
     * `PATCH /api/auth/user/` (urlencoded) - Promises to create a user
     * @param {IUpdateUser} payload - The user's properties
     * @returns - the updated user
     */
    AuthAPI.prototype.updateUser = function (payload) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var avatar, cover, name, username, url, followersCountVisible, bio, location, body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user');
                avatar = payload.avatar, cover = payload.cover, name = payload.name, username = payload.username, url = payload.url, followersCountVisible = payload.followersCountVisible, bio = payload.bio, location = payload.location;
                body = {};
                if (avatar !== undefined) {
                    body.avatar = avatar === null
                        ? avatar
                        : new FileObject_1.FileObject(avatar);
                }
                if (cover !== undefined) {
                    body.cover = cover === null
                        ? cover
                        : new FileObject_1.FileObject(cover);
                }
                if (name) {
                    body.name = name;
                }
                if (username) {
                    body.username = username;
                }
                if (url) {
                    body.url = url;
                }
                if (bio) {
                    body.bio = bio;
                }
                if (followersCountVisible !== undefined) {
                    body.followers_count_visible = followersCountVisible;
                }
                if (location) {
                    body.location = location;
                }
                return [2 /*return*/, this.patchFormdata(body)];
            });
        });
    };
    /**
    * `PATCH /api/auth/user/settings/` (urlencoded) - Promises to update the user's email
    * @param {string} email - The desired email address
    */
    AuthAPI.prototype.updateUserEmail = function (email) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'settings');
                return [2 /*return*/, this.patchFormdata({ email: email })];
            });
        });
    };
    /**
     * `PATCH /api/auth/user/settings/` (urlencoded) - Promises to update the user's passord
     * @param {string} currentPassword - The user's current password
     * @param {string} newPassword - The user's desired new password
     */
    AuthAPI.prototype.updateUserPassword = function (currentPassword, newPassword) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'settings');
                return [2 /*return*/, this.patchFormdata({
                        current_password: currentPassword,
                        new_password: newPassword
                    })];
            });
        });
    };
    /**
     * `POST /api/auth/email/verify/` - Promises to verify a user's email
     * @param {string} token - The verification token
     */
    AuthAPI.prototype.verifyEmailWithToken = function (token) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('email', 'verify');
                return [2 /*return*/, this.post({ token: token })];
            });
        });
    };
    /**
     * `GET /api/auth/user/` - Promises to get a user by auth token
     * @param {string} authToken - The authentication token
     */
    AuthAPI.prototype.getUserWithAuthToken = function (authToken) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = false;
                this._headers['Authorization'] = "Token: " + authToken;
                this._paths.push('user');
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/user/` - Promises to get a user by username
     * @param {string} username - The username to search for
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getUserWithUsername = function (username, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (!authenticatedRequest) {
                    this.requiresToken = false;
                }
                this._paths.push('users', encodeURIComponent(username));
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/user/` - Promises to get a user by a certain query
     * @param {string} query - The search query
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getUsersWithQuery = function (query, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = authenticatedRequest;
                this._paths.push('users');
                this._params.query = query;
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/linked-users/search/` - Promises to search a linked user
     * @param {ISearchLinkedUsers}
     */
    AuthAPI.prototype.searchLinkedUsers = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('linked-users', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.withCommunity) {
                    this._params.with_community = opts.withCommunity;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/linked-users/` - Promises to get an array of linked users
     * @param {IGetLinkedUsers}
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getLinkedUsers = function (opts, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = authenticatedRequest;
                this._paths.push('linked-users');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.withCommunity) {
                    this._params.with_community = opts.withCommunity;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/blocked-users/search/` - Promises to search between blocked users
     * @param {string} query - The search query
     * @param {number | undefined} count - The max number of results
     */
    AuthAPI.prototype.searchBlockedUsers = function (query, count) {
        if (count === void 0) { count = undefined; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('blocked-users', 'search');
                this._params.query = query;
                if (count !== undefined) {
                    this._params.count = count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/blocked-users/` - Promises to get an array of blocked users
     * @param {LimitationParams} opts - Query limitation parameters
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getBlockedUsers = function (opts, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = authenticatedRequest;
                this._paths.push('blocked-users');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/auth/users/:username/block/` - Promises to block a user by username
     * @param {string} username - The username of the user to block
     */
    AuthAPI.prototype.blockUserWithName = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('users', encodeURIComponent(username), 'block');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    /**
     * `POST /api/auth/users/:username/unblock/` - Promises to unblock a user by username
     * @param {string} username - The username of the user to unblock
     */
    AuthAPI.prototype.unblockUserWithName = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('users', encodeURIComponent(username), 'unblock');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    /**
     * `GET /api/auth/followers/search` - Promises to search between followers
     * @param {ISearchFollowers}
     */
    AuthAPI.prototype.searchFollowers = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('followers', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/followers/` - Promises to get an array of followers
     * @param {LimitationParams} opts - Query limitation parameters
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getFollowers = function (opts, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = authenticatedRequest;
                this._paths.push('followers');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/followings/search` - Promises to search between followings
     * @param {ISearchFollowings}
     */
    AuthAPI.prototype.searchFollowings = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('followings', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/auth/followings/` - Promises to get an array of followings
     * @param {LimitationParams} opts - Query limitation parameters
     * @param {boolean} authenticatedRequest - Checks whether the request is authenticated
     */
    AuthAPI.prototype.getFollowings = function (opts, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = authenticatedRequest;
                this._paths.push('followings');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/auth/login/` - Promises to log a user in
     * @param {string} username - The username of the user
     * @param {string} password - The password of the user
     */
    AuthAPI.prototype.login = function (username, password) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('login');
                this.requiresToken = false;
                return [2 /*return*/, this.post({ username: username, password: password })];
            });
        });
    };
    /**
     * `POST /api/auth/password/reset/` - Promises to initiate a password reset process
     * @param {IRequestPasswordReset} opts
     */
    AuthAPI.prototype.requestPasswordReset = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = false;
                this._paths.push('password', 'reset');
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/auth/password/verify/` - Promises to verify a password
     * @param {IVerifyPasswordReset} opts
     */
    AuthAPI.prototype.verifyPasswordReset = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = false;
                this._paths.push('password', 'verify');
                return [2 /*return*/, this.post({
                        new_password: opts.password,
                        token: opts.token
                    })];
            });
        });
    };
    /**
     * `GET /api/auth/user/notifications-settings/` - Promises to retrieve the user's notification settings
     */
    AuthAPI.prototype.getAuthenticatedUserNotificationSettings = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'notifications-settings');
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/auth/user/notifications-settings/` - Promises to update the user's notification settings
     * @param {IUpdateNotificationSettings} opts
     */
    AuthAPI.prototype.updateAuthenticatedUserNotificationSettings = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'notifications-settings');
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/auth/user/accept-guidelines/` - Promises to accept the user guidelines
     */
    AuthAPI.prototype.acceptGuidelines = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'accept-guidelines');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    /**
     * `GET /auth/auth/user/languages/` - Promises to get the user's languages
     */
    AuthAPI.prototype.getAllLanguages = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'languages');
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/auth/user/languages/` - Promises to set a new user language
     * @param {number} languageId - The id of the desired language
     */
    AuthAPI.prototype.setNewLanguage = function (languageId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'languages');
                return [2 /*return*/, this.post({
                        language_id: languageId.toString()
                    })];
            });
        });
    };
    /**
     * `POST /api/auth/users/:username/report/` - Promises to report a user
     * @param {IReportUser} opts
     */
    AuthAPI.prototype.reportUser = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('users', encodeURIComponent(opts.username), 'report');
                body = {
                    category_id: opts.moderationCategoryId
                };
                if (opts.description) {
                    body.description = opts.description;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    return AuthAPI;
}(APIRequest_1.APIRequest));
exports.AuthAPI = AuthAPI;


/***/ }),

/***/ "./lib/api/categories.js":
/*!*******************************!*\
  !*** ./lib/api/categories.js ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * CategoriesAPI - Provides methods to interact with the Categories API
 */
var CategoriesAPI = /** @class */ (function (_super) {
    tslib_1.__extends(CategoriesAPI, _super);
    function CategoriesAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/categories/` - Promises to return a list of categories
     * @returns - an array of categories
     */
    CategoriesAPI.prototype.getCategories = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.get()];
            });
        });
    };
    return CategoriesAPI;
}(APIRequest_1.APIRequest));
exports.CategoriesAPI = CategoriesAPI;


/***/ }),

/***/ "./lib/api/circles.js":
/*!****************************!*\
  !*** ./lib/api/circles.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * CirclesAPI - Provides methods to interact with the Circles API
 */
var CirclesAPI = /** @class */ (function (_super) {
    tslib_1.__extends(CirclesAPI, _super);
    function CirclesAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/circles/` - promises to retrieve all circles
     * @returns - an array of circles
     */
    CirclesAPI.prototype.getCircles = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `PUT /api/circles/` - promises to create a new circle
     * @param {ICreateCircle} opts - The circle's properties
     * @returns - the circle
     */
    CirclesAPI.prototype.createCircle = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.put(opts)];
            });
        });
    };
    /**
     * `PATCH /api/circles/:id/` - promises to update a circle
     * @param {number} id - The ID of the circle
     * @param {IUpdateCircle} - The circle's new properties
     * @returns - the updated circle
     */
    CirclesAPI.prototype.updateCircle = function (id, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.patch(opts)];
            });
        });
    };
    /**
     * `GET /api/circles/:id/` - promises to get a circle
     * @param {number} id - The ID of the circle
     * @returns - the requested circle
     */
    CirclesAPI.prototype.getCircle = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `DELETE /api/circles/:id/` - promises to delete a circle
     * @param {number} id - The ID of the circle
     */
    CirclesAPI.prototype.deleteCircle = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `POST /api/circles/name-check/` - promises to check if a circle name is available
     * @param {string} name - The desired name
     */
    CirclesAPI.prototype.checkNameIsAvailable = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('name-check');
                return [2 /*return*/, this.post({ name: name })];
            });
        });
    };
    return CirclesAPI;
}(APIRequest_1.APIRequest));
exports.CirclesAPI = CirclesAPI;


/***/ }),

/***/ "./lib/api/communities.js":
/*!********************************!*\
  !*** ./lib/api/communities.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
var FileObject_1 = __webpack_require__(/*! ../utils/FileObject */ "./lib/utils/FileObject.js");
var CommunitiesAPI = /** @class */ (function (_super) {
    tslib_1.__extends(CommunitiesAPI, _super);
    function CommunitiesAPI(opts) {
        return _super.call(this, opts) || this;
    }
    CommunitiesAPI.prototype.checkNameIsAvailable = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('name-check');
                return [2 /*return*/, this.post({ name: name })];
            });
        });
    };
    CommunitiesAPI.prototype.getTrendingCommunities = function (authenticatedRequest, category) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        if (category === void 0) { category = null; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('trending');
                this.requiresToken = authenticatedRequest;
                if (category) {
                    this._params.category = category;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.createPost = function (communityName, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var payload;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'posts');
                payload = {};
                if (opts.image) {
                    payload['image'] = new FileObject_1.FileObject(opts.image);
                }
                if (opts.video) {
                    payload['video'] = new FileObject_1.FileObject(opts.video);
                }
                if (opts.text) {
                    payload['text'] = opts.text;
                }
                if (opts.circleIds && opts.circleIds.length) {
                    payload['circle_id'] = opts.circleIds.join(',');
                }
                return [2 /*return*/, this.putFormdata(payload)];
            });
        });
    };
    CommunitiesAPI.prototype.getPostsForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'posts');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.getClosedPostsForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'posts', 'closed');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.getCommunitiesWithQuery = function (query, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('search');
                this._params.query = query;
                this.requiresToken = authenticatedRequest;
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.getCommunity = function (name, authenticatedRequest) {
        if (authenticatedRequest === void 0) { authenticatedRequest = true; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name));
                this.requiresToken = authenticatedRequest;
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.createCommunity = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var payload;
            return tslib_1.__generator(this, function (_a) {
                payload = {
                    name: opts.name,
                    title: opts.title,
                    categories: opts.categories.join(','),
                    type: opts.type
                };
                if (opts.avatar) {
                    payload.avatar = new FileObject_1.FileObject(opts.avatar);
                }
                if (opts.cover) {
                    payload.cover = new FileObject_1.FileObject(opts.cover);
                }
                if (opts.color) {
                    payload.color = opts.color;
                }
                if (opts.rules) {
                    payload.rules = opts.rules;
                }
                if (opts.description) {
                    payload.description = opts.description;
                }
                if (opts.userAdjective) {
                    payload.user_adjective = opts.userAdjective;
                }
                if (opts.usersAdjective) {
                    payload.users_adjective = opts.usersAdjective;
                }
                if (opts.invitesEnabled !== undefined) {
                    payload.invites_enabled = opts.invitesEnabled;
                }
                return [2 /*return*/, this.putFormdata(payload)];
            });
        });
    };
    CommunitiesAPI.prototype.updateCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var payload;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name));
                payload = {};
                if (opts.name) {
                    payload.name = opts.name;
                }
                if (opts.title) {
                    payload.title = opts.title;
                }
                if (opts.categories && opts.categories.length) {
                    payload.categories = opts.categories.join(',');
                }
                if (opts.type) {
                    payload.type = opts.type;
                }
                if (opts.color) {
                    payload.color = opts.color;
                }
                if (opts.rules) {
                    payload.rules = opts.rules;
                }
                if (opts.description) {
                    payload.description = opts.description;
                }
                if (opts.userAdjective) {
                    payload.user_adjective = opts.userAdjective;
                }
                if (opts.usersAdjective) {
                    payload.users_adjective = opts.usersAdjective;
                }
                if (opts.invitesEnabled !== undefined) {
                    payload.invites_enabled = opts.invitesEnabled;
                }
                return [2 /*return*/, this.patchFormdata(payload)];
            });
        });
    };
    CommunitiesAPI.prototype.updateCommunityAvatar = function (name, avatar) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (!avatar.name) {
                    throw new Error('Invalid community avatar!');
                }
                this._paths.push(encodeURIComponent(name), 'avatar');
                return [2 /*return*/, this.putFormdata({ avatar: new FileObject_1.FileObject(avatar) })];
            });
        });
    };
    CommunitiesAPI.prototype.deleteCommunityAvatar = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'avatar');
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.updateCommunityCover = function (name, cover) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (!cover.name) {
                    throw new Error('Invalid community cover!');
                }
                this._paths.push(encodeURIComponent(name), 'cover');
                return [2 /*return*/, this.putFormdata({ cover: new FileObject_1.FileObject(cover) })];
            });
        });
    };
    CommunitiesAPI.prototype.deleteCommunityCover = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'cover');
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.deleteCommunity = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name));
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.getMembersForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'members');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.exclude && opts.exclude.length) {
                    this._params.exclude = opts.exclude.join(',');
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.searchMembers = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'members', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.exclude && opts.exclude.length) {
                    this._params.exclude = opts.exclude.join(',');
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.inviteUserToCommunity = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'invite');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.uninviteUserToCommunity = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'uninvite');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.getJoinedCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('joined');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.offset !== undefined) {
                    this._params.offset = opts.offset;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.searchJoinedCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('joined', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.offset = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.joinCommunity = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'members', 'join');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    CommunitiesAPI.prototype.leaveCommunity = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'members', 'leave');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    CommunitiesAPI.prototype.getModeratorsForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'moderators');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.searchModerators = function (communityName, query) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'moderators', 'search');
                this._params.query = query;
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.addCommunityModerator = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'moderators');
                return [2 /*return*/, this.put({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.removeCommunityModerator = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'moderators', encodeURIComponent(username));
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.getAdministratorsForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'administrators');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.searchAdministrators = function (communityName, query) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'administrators', 'search');
                this._params.query = query;
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.addCommunityAdministrator = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'administrators');
                return [2 /*return*/, this.put({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.removeCommunityAdministrator = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'administrators', encodeURIComponent(username));
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.getBannedUsersForCommunity = function (name, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(name), 'banned-users');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.searchBannedUsers = function (communityName, query) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'banned-users', 'search');
                this._params.query = query;
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.banCommunityUser = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'banned-users', 'ban');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.unbanCommunityUser = function (communityName, username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'banned-users', 'unban');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    CommunitiesAPI.prototype.getFavoriteCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('favorites');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.offset !== undefined) {
                    this._params.offset = opts.offset;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.favoriteCommunity = function (communityName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'favorite');
                return [2 /*return*/, this.put({})];
            });
        });
    };
    CommunitiesAPI.prototype.unfavoriteCommunity = function (communityName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'favorite');
                return [2 /*return*/, this.delete()];
            });
        });
    };
    CommunitiesAPI.prototype.getAdministratedCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('administrated');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.offset !== undefined) {
                    this._params.offset = opts.offset;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.getModeratedCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated');
                this.requiresToken = opts.authenticatedRequest || opts.authenticatedRequest === undefined;
                if (opts.offset !== undefined) {
                    this._params.offset = opts.offset;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    CommunitiesAPI.prototype.reportCommunity = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.communityName), 'report');
                body = {
                    category_id: opts.moderationCategoryId.toString()
                };
                if (opts.description) {
                    body.description = opts.description;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    CommunitiesAPI.prototype.getModeratedObjects = function (communityName, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(communityName), 'moderated-objects');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.statuses && opts.statuses.length) {
                    this._params.statuses = opts.statuses.join(',');
                }
                if (opts.types && opts.types.length) {
                    this._params.types = opts.types.join(',');
                }
                if (opts.verified !== undefined) {
                    this._params.verified = opts.verified;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    return CommunitiesAPI;
}(APIRequest_1.APIRequest));
exports.CommunitiesAPI = CommunitiesAPI;


/***/ }),

/***/ "./lib/api/connections.js":
/*!********************************!*\
  !*** ./lib/api/connections.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * ConnectionsAPI - Provides methods to interact with the Connections API
 */
var ConnectionsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(ConnectionsAPI, _super);
    function ConnectionsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `POST /api/connections/connect/` - Promises to connect to a user
     * @param {IUserConnection} opts
     */
    ConnectionsAPI.prototype.connect = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('connect');
                body = {
                    username: opts.username
                };
                if (opts.circleIds && opts.circleIds.length) {
                    body.circles_ids = opts.circleIds;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    /**
     * `POST /api/connections/confirm/` - Promises to confirm a user connection
     * @param {IUserConnection} opts
     */
    ConnectionsAPI.prototype.confirm = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('confirm');
                body = {
                    username: opts.username
                };
                if (opts.circleIds && opts.circleIds.length) {
                    body.circles_ids = opts.circleIds;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    /**
     * `POST /api/connections/update/` - Promises to update a connection
     * @param {IUserConnection} opts
     */
    ConnectionsAPI.prototype.update = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                body = {
                    username: opts.username
                };
                if (opts.circleIds && opts.circleIds.length) {
                    body.circles_ids = opts.circleIds;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    /**
     * `POST /api/connections/disconnect/` - Promises to disconnect from a user
     * @param {string} username - The user to disconnect from
     */
    ConnectionsAPI.prototype.disconnect = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('disconnect');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    return ConnectionsAPI;
}(APIRequest_1.APIRequest));
exports.ConnectionsAPI = ConnectionsAPI;


/***/ }),

/***/ "./lib/api/devices.js":
/*!****************************!*\
  !*** ./lib/api/devices.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * DevicesAPI - Provides methods to interact with the Devices API
 */
var DevicesAPI = /** @class */ (function (_super) {
    tslib_1.__extends(DevicesAPI, _super);
    function DevicesAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/devices/` - Promises to retrieve an array of devices
     */
    DevicesAPI.prototype.getDevices = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `DELETE /api/devices/` - Promises to delete the devices
     */
    DevicesAPI.prototype.deleteDevices = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `GET /api/devices/uuid/` - Promises to get a device based on its UUID
     * @param {string} uuid - The universally unique identifier of the device
     */
    DevicesAPI.prototype.getDevice = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid));
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `PUT /api/devices/` - Promises to create a device
     * @param {string} uuid - The universally unique identifier of the device
     * @param {string} name - The name of the device
     */
    DevicesAPI.prototype.createDevice = function (uuid, name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.put({ uuid: uuid, name: name })];
            });
        });
    };
    /**
     * `PATCH /api/devices/:uuid/` - Promises to update a device
     * @param {string} uuid - The universally unique identifier of the device
     * @param {string} name - The name of the device
     */
    DevicesAPI.prototype.updateDevice = function (uuid, name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid));
                return [2 /*return*/, this.patch({ name: name })];
            });
        });
    };
    /**
     * `DELETE /api/devices/:uuid/` - Promise to delete a device
     * @param {string} uuid - The universally unique identifier of the device
     */
    DevicesAPI.prototype.deleteDevice = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid));
                return [2 /*return*/, this.delete()];
            });
        });
    };
    return DevicesAPI;
}(APIRequest_1.APIRequest));
exports.DevicesAPI = DevicesAPI;


/***/ }),

/***/ "./lib/api/emojis.js":
/*!***************************!*\
  !*** ./lib/api/emojis.js ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * EmojisAPI - Provides methods to interact with the Emojis API
 */
var EmojisAPI = /** @class */ (function (_super) {
    tslib_1.__extends(EmojisAPI, _super);
    function EmojisAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/emojis/groups/` - Promises to get an array of emoji groups
     */
    EmojisAPI.prototype.getGroups = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('groups');
                return [2 /*return*/, this.get()];
            });
        });
    };
    return EmojisAPI;
}(APIRequest_1.APIRequest));
exports.EmojisAPI = EmojisAPI;


/***/ }),

/***/ "./lib/api/follows.js":
/*!****************************!*\
  !*** ./lib/api/follows.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * FollowsAPI - Provides methods to interact with the Follows API
 */
var FollowsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(FollowsAPI, _super);
    function FollowsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `POST /api/follows/follow/` - Promises to follow a user
     * @param {IUserFollows} opts
     */
    FollowsAPI.prototype.follow = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('follow');
                body = {
                    username: opts.username
                };
                if (opts.listIds && opts.listIds.length) {
                    body.lists_ids = opts.listIds;
                }
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/follows/update/` - Promises to update a following
     * @param {IUserFollows} opts
     */
    FollowsAPI.prototype.update = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('update');
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `POST /api/follows/unfollow/` - Promises to unfollow a user
     * @param {string} username - The username of the user to unfollow
     */
    FollowsAPI.prototype.unfollow = function (username) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('unfollow');
                return [2 /*return*/, this.post({ username: username })];
            });
        });
    };
    return FollowsAPI;
}(APIRequest_1.APIRequest));
exports.FollowsAPI = FollowsAPI;


/***/ }),

/***/ "./lib/api/health.js":
/*!***************************!*\
  !*** ./lib/api/health.js ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * HealthAPI - Provides methods to interact with the Health API
 */
var HealthAPI = /** @class */ (function (_super) {
    tslib_1.__extends(HealthAPI, _super);
    function HealthAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/health/` - Promises to get the server health
     */
    HealthAPI.prototype.getHealth = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.requiresToken = false;
                return [2 /*return*/, this.get()];
            });
        });
    };
    return HealthAPI;
}(APIRequest_1.APIRequest));
exports.HealthAPI = HealthAPI;


/***/ }),

/***/ "./lib/api/lists.js":
/*!**************************!*\
  !*** ./lib/api/lists.js ***!
  \**************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * ListsAPI - Provides methods to interact with the Lists API
 */
var ListsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(ListsAPI, _super);
    function ListsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/lists/` - promises to retrieve all lists
     * @returns - an array of lists
     */
    ListsAPI.prototype.getLists = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `PUT /api/lists/` - promises to create a new circle
     * @param {ICreateList} opts - The circle's properties
     * @returns - the circle
     */
    ListsAPI.prototype.createList = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                body = {
                    name: opts.name
                };
                if (opts.emojiId !== undefined) {
                    body.emoji_id = opts.emojiId;
                }
                return [2 /*return*/, this.put(body)];
            });
        });
    };
    /**
     * `PATCH /api/lists/:id/` - promises to update a circle
     * @param {number} id - The ID of the circle
     * @param {IUpdateList} - The circle's new properties
     * @returns - the updated circle
     */
    ListsAPI.prototype.updateList = function (id, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                body = {
                    name: opts.name,
                };
                if (opts.emojiId !== undefined) {
                    body.emoji_id = opts.emojiId;
                }
                if (opts.usernames && opts.usernames.length) {
                    body.usernames = opts.usernames;
                }
                return [2 /*return*/, this.patch(body)];
            });
        });
    };
    /**
     * `DELETE /api/lists/:id/` - promises to delete a circle
     * @param {number} id - The ID of the circle
     */
    ListsAPI.prototype.deleteList = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `GET /api/lists/:id/` - promises to get a circle
     * @param {number} id - The ID of the circle
     * @returns - the requested circle
     */
    ListsAPI.prototype.getList = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/lists/name-check/` - promises to check if a circle name is available
     * @param {string} name - The desired name
     */
    ListsAPI.prototype.checkNameIsAvailable = function (name) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('name-check');
                return [2 /*return*/, this.post({ name: name })];
            });
        });
    };
    return ListsAPI;
}(APIRequest_1.APIRequest));
exports.ListsAPI = ListsAPI;


/***/ }),

/***/ "./lib/api/moderation.js":
/*!*******************************!*\
  !*** ./lib/api/moderation.js ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
var ModerationAPI = /** @class */ (function (_super) {
    tslib_1.__extends(ModerationAPI, _super);
    function ModerationAPI(opts) {
        return _super.call(this, opts) || this;
    }
    ModerationAPI.prototype.getGlobalModeratedObjects = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', 'global');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.statuses && opts.statuses.length) {
                    this._params.statuses = opts.statuses.join(',');
                }
                if (opts.types && opts.types.length) {
                    this._params.types = opts.types.join(',');
                }
                if (opts.verified !== undefined) {
                    this._params.verified = opts.verified;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModeratedObjectLogs = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', encodeURIComponent(opts.id), 'logs');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModeratedObjectReports = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', encodeURIComponent(opts.id), 'reports');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getModerationCategories = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('categories');
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getUserModerationPenalties = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'penalties');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.getUserPendingModeratedObjectsCommunities = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('user', 'pending-moderated-objects-communities');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    ModerationAPI.prototype.verifyModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'verify');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.unverifyModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'unverify');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.approveModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'approve');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.rejectModeratedObject = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString(), 'reject');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    ModerationAPI.prototype.updateModeratedObject = function (id, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('moderated-objects', id.toString());
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    return ModerationAPI;
}(APIRequest_1.APIRequest));
exports.ModerationAPI = ModerationAPI;


/***/ }),

/***/ "./lib/api/notifications.js":
/*!**********************************!*\
  !*** ./lib/api/notifications.js ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * NotificationsAPI - Provides methods to interact with the Notifications API
 */
var NotificationsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(NotificationsAPI, _super);
    function NotificationsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `GET /api/notifications/` - promises to retrieve the user's notifications
     * @param {LimitationParams} opts - The limitation rules
     */
    NotificationsAPI.prototype.getNotifications = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (opts.maxId) {
                    this._params.maxId = opts.maxId;
                }
                if (opts.count) {
                    this._params.count = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/notifications/read/` - promises to mark notifications as read
     * @param {LimitationParams} opts - The limitation rules
     */
    NotificationsAPI.prototype.readNotifications = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('read');
                return [2 /*return*/, this.post(opts)];
            });
        });
    };
    /**
     * `DELETE /api/notifications/` - promises to delete all notifications
     */
    NotificationsAPI.prototype.deleteNotifications = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `DELETE /api/notifications/:id/` - promises to delete a notification
     * @param {number} id - The ID of the notification
     */
    NotificationsAPI.prototype.deleteNotification = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `GET /api/notifications/:id/` - promises to get a notification
     * @param {number} id - The ID of the notification
     */
    NotificationsAPI.prototype.getNotification = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `POST /api/notifications/:id/` - promises to mark a notification as read
     * @param {number} id - The ID of the notification
     */
    NotificationsAPI.prototype.readNotification = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.post({})];
            });
        });
    };
    return NotificationsAPI;
}(APIRequest_1.APIRequest));
exports.NotificationsAPI = NotificationsAPI;


/***/ }),

/***/ "./lib/api/posts.js":
/*!**************************!*\
  !*** ./lib/api/posts.js ***!
  \**************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
var FileObject_1 = __webpack_require__(/*! ../utils/FileObject */ "./lib/utils/FileObject.js");
var PostsAPI = /** @class */ (function (_super) {
    tslib_1.__extends(PostsAPI, _super);
    function PostsAPI(opts) {
        return _super.call(this, opts) || this;
    }
    PostsAPI.prototype.getTimelinePosts = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (opts.listIds && opts.listIds.length) {
                    this._params['list_id'] = opts.listIds.join(',');
                }
                if (opts.circleIds && opts.circleIds.length) {
                    this._params['circle_id'] = opts.circleIds.join(',');
                }
                if (opts.count !== undefined) {
                    this._params['count'] = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params['max_id'] = opts.maxId;
                }
                if (opts.username) {
                    this._params['username'] = opts.username;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.createPost = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var payload;
            return tslib_1.__generator(this, function (_a) {
                payload = {};
                if (opts.image) {
                    payload['image'] = new FileObject_1.FileObject(opts.image);
                }
                if (opts.video) {
                    payload['video'] = new FileObject_1.FileObject(opts.video);
                }
                if (opts.text) {
                    payload['text'] = opts.text;
                }
                if (opts.circleIds && opts.circleIds.length) {
                    payload['circle_id'] = opts.circleIds.join(',');
                }
                return [2 /*return*/, this.putFormdata(payload)];
            });
        });
    };
    PostsAPI.prototype.getTrendingPosts = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('trending');
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.editPost = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var payload;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.uuid));
                payload = {
                    post_uuid: opts.uuid
                };
                if (opts.text) {
                    payload['text'] = opts.text;
                }
                return [2 /*return*/, this.patchFormdata(payload)];
            });
        });
    };
    PostsAPI.prototype.getPostWithUuid = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid));
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.deletePostWithUuid = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid));
                return [2 /*return*/, this.delete()];
            });
        });
    };
    PostsAPI.prototype.getCommentsForPost = function (uuid, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'comments');
                if (opts.countMax !== undefined) {
                    this._params.count_max = opts.countMax;
                }
                if (opts.countMin !== undefined) {
                    this._params.count_min = opts.countMin;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.minId !== undefined) {
                    this._params.min_id = opts.minId;
                }
                if (opts.sort) {
                    this._params.sort = opts.sort;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.getRepliesForPostComment = function (postUuid, postCommentId, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', postCommentId.toString());
                if (opts.countMax !== undefined) {
                    this._params.count_max = opts.countMax;
                }
                if (opts.countMin !== undefined) {
                    this._params.count_min = opts.countMin;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.minId !== undefined) {
                    this._params.min_id = opts.minId;
                }
                if (opts.sort) {
                    this._params.sort = opts.sort;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.commentOnPost = function (uuid, text) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'comments');
                return [2 /*return*/, this.put({ text: text })];
            });
        });
    };
    PostsAPI.prototype.editPostComment = function (postUuid, commentId, text) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString());
                return [2 /*return*/, this.patch({ text: text })];
            });
        });
    };
    PostsAPI.prototype.replyPostComment = function (postUuid, commentId, text) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'replies');
                return [2 /*return*/, this.put({ text: text })];
            });
        });
    };
    PostsAPI.prototype.deletePostComment = function (postUuid, commentId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    PostsAPI.prototype.getReactionsForPost = function (uuid, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'reactions');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.emojiId !== undefined) {
                    this._params.emoji_id = opts.emojiId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.getReactionsEmojiCountForPost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'reactions', 'emoji-count');
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.reactToPost = function (uuid, emojiId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'reactions');
                return [2 /*return*/, this.put({ emoji_id: emojiId })];
            });
        });
    };
    PostsAPI.prototype.deletePostReaction = function (postUuid, reactionId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'reactions', reactionId.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    PostsAPI.prototype.getReactionsForPostComment = function (postUuid, commentId, opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'reactions');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                if (opts.maxId !== undefined) {
                    this._params.max_id = opts.maxId;
                }
                if (opts.emojiId !== undefined) {
                    this._params.emoji_id = opts.emojiId;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.getReactionsEmojiCountForPostComment = function (postUuid, commentId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'reactions', 'emoji-count');
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.reactToPostComment = function (postUuid, commentId, emojiId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'reactions');
                return [2 /*return*/, this.put({ emoji_id: emojiId })];
            });
        });
    };
    PostsAPI.prototype.deletePostCommentReaction = function (postUuid, commentId, reactionId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'reactions', reactionId.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    PostsAPI.prototype.mutePostComment = function (postUuid, commentId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'notifications', 'mute');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.unmutePostComment = function (postUuid, commentId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'notifications', 'unmute');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.mutePost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'notifications', 'mute');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.unmutePost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'notifications', 'unmute');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.disableCommentsForPost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'comments', 'disable');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.enableCommentsForPost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'comments', 'enable');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.openPost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'open');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.closePost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'close');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.getReactionEmojiGroups = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('emojis/groups');
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.reportPost = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.postUuid), 'report');
                body = {
                    category_id: opts.moderationCategoryId.toString()
                };
                if (opts.description) {
                    body.description = opts.description;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    PostsAPI.prototype.reportPostComment = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.postUuid), 'comments', opts.commentId.toString(), 'report');
                body = {
                    category_id: opts.moderationCategoryId.toString()
                };
                if (opts.description) {
                    body.description = opts.description;
                }
                return [2 /*return*/, this.post(body)];
            });
        });
    };
    PostsAPI.prototype.translatePost = function (uuid) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(uuid), 'translate');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.translatePostComment = function (postUuid, commentId) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(postUuid), 'comments', commentId.toString(), 'translate');
                return [2 /*return*/, this.post({})];
            });
        });
    };
    PostsAPI.prototype.getPostParticipants = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.postUuid), 'participants');
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    PostsAPI.prototype.searchPostParticipants = function (opts) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(encodeURIComponent(opts.postUuid), 'participants', 'search');
                this._params.query = opts.query;
                if (opts.count !== undefined) {
                    this._params.count = opts.count;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    return PostsAPI;
}(APIRequest_1.APIRequest));
exports.PostsAPI = PostsAPI;


/***/ }),

/***/ "./lib/api/userInvites.js":
/*!********************************!*\
  !*** ./lib/api/userInvites.js ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var APIRequest_1 = __webpack_require__(/*! ../utils/APIRequest */ "./lib/utils/APIRequest.js");
/**
 * @api public
 * UserInvitesAPI - Provides methods to interact with the User Invites API
 */
var UserInvitesAPI = /** @class */ (function (_super) {
    tslib_1.__extends(UserInvitesAPI, _super);
    function UserInvitesAPI(opts) {
        return _super.call(this, opts) || this;
    }
    /**
     * `PUT /api/invites/` - promises to create an invite
     * @param {string} nickname - A nickname for the notification
     */
    UserInvitesAPI.prototype.create = function (nickname) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body;
            return tslib_1.__generator(this, function (_a) {
                body = {};
                if (nickname) {
                    body['nickname'] = nickname;
                }
                return [2 /*return*/, this.putFormdata(body)];
            });
        });
    };
    /**
     * `PATCH /api/invites/` - promises to update a notification's nickname
     * @param {string} id - The ID of the notification
     * @param {string} nickname - The new nickname
     */
    UserInvitesAPI.prototype.update = function (id, nickname) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.patchFormdata({ nickname: nickname })];
            });
        });
    };
    /**
     * `GET /api/invites/` - promises to retrieve a list of all invites
     * @param {number} offset
     * @param {number} count
     * @param {boolean} pending
     */
    UserInvitesAPI.prototype.getUserInvites = function (offset, count, pending) {
        if (offset === void 0) { offset = null; }
        if (count === void 0) { count = null; }
        if (pending === void 0) { pending = null; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (offset !== null) {
                    this._params['offset'] = offset;
                }
                if (count !== null) {
                    this._params['count'] = count;
                }
                if (pending !== null) {
                    this._params['pending'] = pending;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `GET /api/invites/search/` - promises to search between the user invites
     * @param {string} query
     * @param {number} count
     * @param {boolean} pending
     */
    UserInvitesAPI.prototype.searchUserInvite = function (query, count, pending) {
        if (count === void 0) { count = null; }
        if (pending === void 0) { pending = null; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push('search');
                this._params['query'] = encodeURIComponent(query);
                if (count !== null) {
                    this._params['count'] = count;
                }
                if (pending !== null) {
                    this._params['pending'] = pending;
                }
                return [2 /*return*/, this.get()];
            });
        });
    };
    /**
     * `DELETE /api/invites/:id/` - promises to delete an invite
     * @param {number} id - The ID of the invite
     */
    UserInvitesAPI.prototype.deleteUserInvite = function (id) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString());
                return [2 /*return*/, this.delete()];
            });
        });
    };
    /**
     * `POST /api/invites/:id/email/` - promises to sent an email with the invitation
     * @param {number} id - The ID of the invite
     * @param {string} email - The email to which the invite will be sent
     */
    UserInvitesAPI.prototype.email = function (id, email) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this._paths.push(id.toString(), 'email');
                return [2 /*return*/, this.post({ email: email })];
            });
        });
    };
    return UserInvitesAPI;
}(APIRequest_1.APIRequest));
exports.UserInvitesAPI = UserInvitesAPI;


/***/ }),

/***/ "./lib/utils/APIRequest.js":
/*!*********************************!*\
  !*** ./lib/utils/APIRequest.js ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var buildUrl_1 = tslib_1.__importDefault(__webpack_require__(/*! ./buildUrl */ "./lib/utils/buildUrl.js"));
var requestStrategies_1 = __webpack_require__(/*! ./requestStrategies */ "./lib/utils/requestStrategies/index.js");
__webpack_require__(/*! isomorphic-form-data */ "./node_modules/isomorphic-form-data/lib/browser.js");
/**
 * @api
 */
var APIRequest = /** @class */ (function () {
    function APIRequest(opts) {
        this._paths = [];
        this._params = {};
        this._headers = {};
        this.requiresToken = true;
        this._okuna = opts.okuna;
        this._endpoint = opts.endpoint;
        this._paths = [this._endpoint];
        this._url = "" + this._okuna.apiUrl + this._endpoint;
        this._api = requestStrategies_1.getRequestStrategy(this._okuna.requestStrategy);
    }
    /**
     * generateHeaders()
     * A function used to generate the headers that need to be
     * passed to the request performee.
     * @returns {object}
     */
    APIRequest.prototype.generateHeaders = function (contentType) {
        var _a;
        if (contentType === void 0) { contentType = null; }
        var headers = {
            'Accept': 'application/json'
        };
        if (contentType !== 'auto') {
            Object.assign(headers, { 'Content-Type': contentType || 'application/json' });
        }
        if (this._okuna.magicHeaderName && this._okuna.magicHeaderValue) {
            Object.assign(headers, (_a = {}, _a[this._okuna.magicHeaderName] = this._okuna.magicHeaderValue, _a));
        }
        if (this.requiresToken) {
            if (!this._okuna.authToken) {
                throw new Error('Authorization token not provided.');
            }
            Object.assign(headers, { 'Authorization': "Token " + this._okuna.authToken });
        }
        return headers;
    };
    /**
     * constructFormdata()
     * Constructs a FormData instance from an object.
     * @param {object} opts - the object to generate the FormData from
     * @returns {FormData}
     */
    APIRequest.prototype._constructFormdata = function (opts) {
        if (opts === void 0) { opts = null; }
        var form = new FormData();
        if (!opts) {
            return form;
        }
        Object.keys(opts).forEach(function (key) {
            var value = opts[key];
            // istanbul ignore next
            if (value.isValidFileObject) {
                return form.append(key, value.file, value.name);
            }
            return form.append(key, value);
        });
        return form;
    };
    /**
     * get()
     * GET request
     * @returns {Promise<any>}
     */
    APIRequest.prototype.get = function () {
        var _this = this;
        this._headers = this.generateHeaders();
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.get(_this._url, { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * put()
     * PUT request
     * @param {object} body - Request body
     */
    APIRequest.prototype.put = function (body) {
        var _this = this;
        this._headers = this.generateHeaders();
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.put(_this._url, JSON.stringify(body), { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * post()
     * POST request
     * @param {object} body - Request body
     */
    APIRequest.prototype.post = function (body) {
        var _this = this;
        this._headers = this.generateHeaders();
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.post(_this._url, JSON.stringify(body), { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * patch()
     * PATCH request
     * @param {object} body - Request body
     */
    APIRequest.prototype.patch = function (body) {
        var _this = this;
        this._headers = this.generateHeaders();
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.patch(_this._url, JSON.stringify(body), { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * delete()
     * DELETE request
     * @returns {Promise<any>}
     */
    APIRequest.prototype.delete = function () {
        var _this = this;
        this._headers = this.generateHeaders();
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.delete(_this._url, { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * putFormdata()
     * PUT request (multipart/form-data, application/x-www-form-urlencoded)
     */
    APIRequest.prototype.putFormdata = function (body) {
        var _this = this;
        var form = this._constructFormdata(body);
        this._headers = this.generateHeaders('auto');
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.put(_this._url, form, { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * postFormdata()
     * POST request (multipart/form-data, application/x-www-form-urlencoded)
     */
    APIRequest.prototype.postFormdata = function (body) {
        var _this = this;
        var form = this._constructFormdata(body);
        this._headers = this.generateHeaders('auto');
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.post(_this._url, form, { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    /**
     * patchFormdata()
     * PATCH request (multipart/form-data, application/x-www-form-urlencoded)
     */
    APIRequest.prototype.patchFormdata = function (body) {
        var _this = this;
        var form = this._constructFormdata(body);
        this._headers = this.generateHeaders('auto');
        this._url = buildUrl_1.default(this._okuna.apiUrl, this._paths, this._params);
        return new Promise(function (resolve, reject) {
            return _this._api.patch(_this._url, form, { headers: _this._headers })
                .then(function (res) { return resolve(res.data); })
                .catch(function (err) { return reject(err); });
        });
    };
    return APIRequest;
}());
exports.APIRequest = APIRequest;


/***/ }),

/***/ "./lib/utils/FileObject.js":
/*!*********************************!*\
  !*** ./lib/utils/FileObject.js ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @api private
 * FileObject - describes a file object.
 */
var FileObject = /** @class */ (function () {
    /**
     * @constructor
     * @param {any} file - The raw file
     * @param {string} name - The name of the file
     */
    function FileObject(opts) {
        this.isValidFileObject = false;
        if (!opts.file || !opts.name) {
            throw new Error('You must provide the file and its name.');
        }
        this.file = opts.file;
        this.name = opts.name;
        this.isValidFileObject = true;
    }
    return FileObject;
}());
exports.FileObject = FileObject;


/***/ }),

/***/ "./lib/utils/buildUrl.js":
/*!*******************************!*\
  !*** ./lib/utils/buildUrl.js ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
/**
 * buildUrl()
 * Creates a fetchable URL
 * @param {string} apiUrl - The URL address of the Okuna API server
 * @param {string[]} paths - An array containing additional paths for the endpoint
 * @param {object} params - Key-value properties to append to the URL (mainly used for GET requests)
 * @returns {string} - The final URL to fetch
 */
var buildUrl = function (apiUrl, paths, params) {
    if (apiUrl.slice(-1) === '/') {
        apiUrl = apiUrl.slice(0, -1);
    }
    var _paths = paths.join('/');
    var _params = Object.keys(params)
        .map(function (key) { return key + "=" + params[key]; })
        .join('&');
    return _params
        ? "" + apiUrl + _paths + "/?" + _params
        : "" + apiUrl + _paths + "/";
};
exports.default = buildUrl;


/***/ }),

/***/ "./lib/utils/requestStrategies/AxiosStrategy.js":
/*!******************************************************!*\
  !*** ./lib/utils/requestStrategies/AxiosStrategy.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var axios_1 = tslib_1.__importDefault(__webpack_require__(/*! axios */ "./node_modules/axios/index.js"));
var core_1 = tslib_1.__importDefault(__webpack_require__(/*! ./core */ "./lib/utils/requestStrategies/core.js"));
/**
 * @api
 * WARNING: The Axios strategy currently does not work well with
 * multipart/form-data and application/x-www-form-urlencoded
 */
var AxiosStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(AxiosStrategy, _super);
    function AxiosStrategy() {
        return _super.call(this, 'axios') || this;
    }
    AxiosStrategy.prototype.get = function (url, opts) {
        return axios_1.default.get(url, opts);
    };
    AxiosStrategy.prototype.post = function (url, body, opts) {
        return axios_1.default.post(url, body, opts);
    };
    AxiosStrategy.prototype.put = function (url, body, opts) {
        return axios_1.default.put(url, body, opts);
    };
    AxiosStrategy.prototype.patch = function (url, body, opts) {
        return axios_1.default.patch(url, body, opts);
    };
    AxiosStrategy.prototype.delete = function (url, opts) {
        return axios_1.default.delete(url, opts);
    };
    return AxiosStrategy;
}(core_1.default));
module.exports = AxiosStrategy;


/***/ }),

/***/ "./lib/utils/requestStrategies/FetchStrategy.js":
/*!******************************************************!*\
  !*** ./lib/utils/requestStrategies/FetchStrategy.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var core_1 = tslib_1.__importDefault(__webpack_require__(/*! ./core */ "./lib/utils/requestStrategies/core.js"));
var es6_promise_1 = tslib_1.__importDefault(__webpack_require__(/*! es6-promise */ "./node_modules/es6-promise/dist/es6-promise.js"));
es6_promise_1.default.polyfill();
__webpack_require__(/*! isomorphic-form-data */ "./node_modules/isomorphic-form-data/lib/browser.js");
__webpack_require__(/*! isomorphic-fetch */ "./node_modules/isomorphic-fetch/fetch-npm-browserify.js");
/**
 * @api
 */
var FetchStrategy = /** @class */ (function (_super) {
    tslib_1.__extends(FetchStrategy, _super);
    function FetchStrategy() {
        return _super.call(this, 'fetch') || this;
    }
    FetchStrategy.prototype.get = function (url, opts) {
        return new Promise(function (resolve, reject) {
            return fetch(url, tslib_1.__assign({ method: 'GET' }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.post = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'POST', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.put = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'PUT', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.patch = function (url, payload, opts) {
        return new Promise(function (resolve, reject) {
            var body = typeof payload === 'object' && payload.constructor === Object
                ? JSON.stringify(payload)
                : payload;
            return fetch(url, tslib_1.__assign({ method: 'PATCH', body: body }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    FetchStrategy.prototype.delete = function (url, opts) {
        return new Promise(function (resolve, reject) {
            return fetch(url, tslib_1.__assign({ method: 'DELETE' }, opts))
                .then(function (response) {
                if (!response.ok) {
                    return reject(response);
                }
                return response.json();
            })
                .then(function (json) {
                return {
                    data: json
                };
            })
                .then(function (response) { return resolve(response); })
                .catch(function (err) { return reject(err); });
        });
    };
    return FetchStrategy;
}(core_1.default));
module.exports = FetchStrategy;


/***/ }),

/***/ "./lib/utils/requestStrategies/core.js":
/*!*********************************************!*\
  !*** ./lib/utils/requestStrategies/core.js ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var RequestStrategy = /** @class */ (function () {
    function RequestStrategy(name) {
        this.name = name;
    }
    return RequestStrategy;
}());
module.exports = RequestStrategy;


/***/ }),

/***/ "./lib/utils/requestStrategies/index.js":
/*!**********************************************!*\
  !*** ./lib/utils/requestStrategies/index.js ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
var core_1 = tslib_1.__importDefault(__webpack_require__(/*! ./core */ "./lib/utils/requestStrategies/core.js"));
exports.RequestStrategy = core_1.default;
var AxiosStrategy_1 = tslib_1.__importDefault(__webpack_require__(/*! ./AxiosStrategy */ "./lib/utils/requestStrategies/AxiosStrategy.js"));
var FetchStrategy_1 = tslib_1.__importDefault(__webpack_require__(/*! ./FetchStrategy */ "./lib/utils/requestStrategies/FetchStrategy.js"));
var getRequestStrategy = function (strategy) {
    if (typeof strategy === 'function' && strategy.prototype instanceof core_1.default) {
        return new strategy();
    }
    if (strategy === 'axios') {
        return new AxiosStrategy_1.default();
    }
    if (strategy === 'fetch') {
        return new FetchStrategy_1.default();
    }
    throw new Error("Unknown request strategy: " + strategy + ".");
};
exports.getRequestStrategy = getRequestStrategy;


/***/ }),

/***/ "./node_modules/axios/index.js":
/*!*************************************!*\
  !*** ./node_modules/axios/index.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! ./lib/axios */ "./node_modules/axios/lib/axios.js");

/***/ }),

/***/ "./node_modules/axios/lib/adapters/xhr.js":
/*!************************************************!*\
  !*** ./node_modules/axios/lib/adapters/xhr.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");
var settle = __webpack_require__(/*! ./../core/settle */ "./node_modules/axios/lib/core/settle.js");
var buildURL = __webpack_require__(/*! ./../helpers/buildURL */ "./node_modules/axios/lib/helpers/buildURL.js");
var parseHeaders = __webpack_require__(/*! ./../helpers/parseHeaders */ "./node_modules/axios/lib/helpers/parseHeaders.js");
var isURLSameOrigin = __webpack_require__(/*! ./../helpers/isURLSameOrigin */ "./node_modules/axios/lib/helpers/isURLSameOrigin.js");
var createError = __webpack_require__(/*! ../core/createError */ "./node_modules/axios/lib/core/createError.js");

module.exports = function xhrAdapter(config) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    var requestData = config.data;
    var requestHeaders = config.headers;

    if (utils.isFormData(requestData)) {
      delete requestHeaders['Content-Type']; // Let the browser set it
    }

    var request = new XMLHttpRequest();

    // HTTP basic authentication
    if (config.auth) {
      var username = config.auth.username || '';
      var password = config.auth.password || '';
      requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
    }

    request.open(config.method.toUpperCase(), buildURL(config.url, config.params, config.paramsSerializer), true);

    // Set the request timeout in MS
    request.timeout = config.timeout;

    // Listen for ready state
    request.onreadystatechange = function handleLoad() {
      if (!request || request.readyState !== 4) {
        return;
      }

      // The request errored out and we didn't get a response, this will be
      // handled by onerror instead
      // With one exception: request that using file: protocol, most browsers
      // will return status as 0 even though it's a successful request
      if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
        return;
      }

      // Prepare the response
      var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
      var responseData = !config.responseType || config.responseType === 'text' ? request.responseText : request.response;
      var response = {
        data: responseData,
        status: request.status,
        statusText: request.statusText,
        headers: responseHeaders,
        config: config,
        request: request
      };

      settle(resolve, reject, response);

      // Clean up request
      request = null;
    };

    // Handle browser request cancellation (as opposed to a manual cancellation)
    request.onabort = function handleAbort() {
      if (!request) {
        return;
      }

      reject(createError('Request aborted', config, 'ECONNABORTED', request));

      // Clean up request
      request = null;
    };

    // Handle low level network errors
    request.onerror = function handleError() {
      // Real errors are hidden from us by the browser
      // onerror should only fire if it's a network error
      reject(createError('Network Error', config, null, request));

      // Clean up request
      request = null;
    };

    // Handle timeout
    request.ontimeout = function handleTimeout() {
      reject(createError('timeout of ' + config.timeout + 'ms exceeded', config, 'ECONNABORTED',
        request));

      // Clean up request
      request = null;
    };

    // Add xsrf header
    // This is only done if running in a standard browser environment.
    // Specifically not if we're in a web worker, or react-native.
    if (utils.isStandardBrowserEnv()) {
      var cookies = __webpack_require__(/*! ./../helpers/cookies */ "./node_modules/axios/lib/helpers/cookies.js");

      // Add xsrf header
      var xsrfValue = (config.withCredentials || isURLSameOrigin(config.url)) && config.xsrfCookieName ?
        cookies.read(config.xsrfCookieName) :
        undefined;

      if (xsrfValue) {
        requestHeaders[config.xsrfHeaderName] = xsrfValue;
      }
    }

    // Add headers to the request
    if ('setRequestHeader' in request) {
      utils.forEach(requestHeaders, function setRequestHeader(val, key) {
        if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
          // Remove Content-Type if data is undefined
          delete requestHeaders[key];
        } else {
          // Otherwise add header to the request
          request.setRequestHeader(key, val);
        }
      });
    }

    // Add withCredentials to request if needed
    if (config.withCredentials) {
      request.withCredentials = true;
    }

    // Add responseType to request if needed
    if (config.responseType) {
      try {
        request.responseType = config.responseType;
      } catch (e) {
        // Expected DOMException thrown by browsers not compatible XMLHttpRequest Level 2.
        // But, this can be suppressed for 'json' type as it can be parsed by default 'transformResponse' function.
        if (config.responseType !== 'json') {
          throw e;
        }
      }
    }

    // Handle progress if needed
    if (typeof config.onDownloadProgress === 'function') {
      request.addEventListener('progress', config.onDownloadProgress);
    }

    // Not all browsers support upload events
    if (typeof config.onUploadProgress === 'function' && request.upload) {
      request.upload.addEventListener('progress', config.onUploadProgress);
    }

    if (config.cancelToken) {
      // Handle cancellation
      config.cancelToken.promise.then(function onCanceled(cancel) {
        if (!request) {
          return;
        }

        request.abort();
        reject(cancel);
        // Clean up request
        request = null;
      });
    }

    if (requestData === undefined) {
      requestData = null;
    }

    // Send the request
    request.send(requestData);
  });
};


/***/ }),

/***/ "./node_modules/axios/lib/axios.js":
/*!*****************************************!*\
  !*** ./node_modules/axios/lib/axios.js ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/axios/lib/utils.js");
var bind = __webpack_require__(/*! ./helpers/bind */ "./node_modules/axios/lib/helpers/bind.js");
var Axios = __webpack_require__(/*! ./core/Axios */ "./node_modules/axios/lib/core/Axios.js");
var mergeConfig = __webpack_require__(/*! ./core/mergeConfig */ "./node_modules/axios/lib/core/mergeConfig.js");
var defaults = __webpack_require__(/*! ./defaults */ "./node_modules/axios/lib/defaults.js");

/**
 * Create an instance of Axios
 *
 * @param {Object} defaultConfig The default config for the instance
 * @return {Axios} A new instance of Axios
 */
function createInstance(defaultConfig) {
  var context = new Axios(defaultConfig);
  var instance = bind(Axios.prototype.request, context);

  // Copy axios.prototype to instance
  utils.extend(instance, Axios.prototype, context);

  // Copy context to instance
  utils.extend(instance, context);

  return instance;
}

// Create the default instance to be exported
var axios = createInstance(defaults);

// Expose Axios class to allow class inheritance
axios.Axios = Axios;

// Factory for creating new instances
axios.create = function create(instanceConfig) {
  return createInstance(mergeConfig(axios.defaults, instanceConfig));
};

// Expose Cancel & CancelToken
axios.Cancel = __webpack_require__(/*! ./cancel/Cancel */ "./node_modules/axios/lib/cancel/Cancel.js");
axios.CancelToken = __webpack_require__(/*! ./cancel/CancelToken */ "./node_modules/axios/lib/cancel/CancelToken.js");
axios.isCancel = __webpack_require__(/*! ./cancel/isCancel */ "./node_modules/axios/lib/cancel/isCancel.js");

// Expose all/spread
axios.all = function all(promises) {
  return Promise.all(promises);
};
axios.spread = __webpack_require__(/*! ./helpers/spread */ "./node_modules/axios/lib/helpers/spread.js");

module.exports = axios;

// Allow use of default import syntax in TypeScript
module.exports.default = axios;


/***/ }),

/***/ "./node_modules/axios/lib/cancel/Cancel.js":
/*!*************************************************!*\
  !*** ./node_modules/axios/lib/cancel/Cancel.js ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * A `Cancel` is an object that is thrown when an operation is canceled.
 *
 * @class
 * @param {string=} message The message.
 */
function Cancel(message) {
  this.message = message;
}

Cancel.prototype.toString = function toString() {
  return 'Cancel' + (this.message ? ': ' + this.message : '');
};

Cancel.prototype.__CANCEL__ = true;

module.exports = Cancel;


/***/ }),

/***/ "./node_modules/axios/lib/cancel/CancelToken.js":
/*!******************************************************!*\
  !*** ./node_modules/axios/lib/cancel/CancelToken.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var Cancel = __webpack_require__(/*! ./Cancel */ "./node_modules/axios/lib/cancel/Cancel.js");

/**
 * A `CancelToken` is an object that can be used to request cancellation of an operation.
 *
 * @class
 * @param {Function} executor The executor function.
 */
function CancelToken(executor) {
  if (typeof executor !== 'function') {
    throw new TypeError('executor must be a function.');
  }

  var resolvePromise;
  this.promise = new Promise(function promiseExecutor(resolve) {
    resolvePromise = resolve;
  });

  var token = this;
  executor(function cancel(message) {
    if (token.reason) {
      // Cancellation has already been requested
      return;
    }

    token.reason = new Cancel(message);
    resolvePromise(token.reason);
  });
}

/**
 * Throws a `Cancel` if cancellation has been requested.
 */
CancelToken.prototype.throwIfRequested = function throwIfRequested() {
  if (this.reason) {
    throw this.reason;
  }
};

/**
 * Returns an object that contains a new `CancelToken` and a function that, when called,
 * cancels the `CancelToken`.
 */
CancelToken.source = function source() {
  var cancel;
  var token = new CancelToken(function executor(c) {
    cancel = c;
  });
  return {
    token: token,
    cancel: cancel
  };
};

module.exports = CancelToken;


/***/ }),

/***/ "./node_modules/axios/lib/cancel/isCancel.js":
/*!***************************************************!*\
  !*** ./node_modules/axios/lib/cancel/isCancel.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function isCancel(value) {
  return !!(value && value.__CANCEL__);
};


/***/ }),

/***/ "./node_modules/axios/lib/core/Axios.js":
/*!**********************************************!*\
  !*** ./node_modules/axios/lib/core/Axios.js ***!
  \**********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");
var buildURL = __webpack_require__(/*! ../helpers/buildURL */ "./node_modules/axios/lib/helpers/buildURL.js");
var InterceptorManager = __webpack_require__(/*! ./InterceptorManager */ "./node_modules/axios/lib/core/InterceptorManager.js");
var dispatchRequest = __webpack_require__(/*! ./dispatchRequest */ "./node_modules/axios/lib/core/dispatchRequest.js");
var mergeConfig = __webpack_require__(/*! ./mergeConfig */ "./node_modules/axios/lib/core/mergeConfig.js");

/**
 * Create a new instance of Axios
 *
 * @param {Object} instanceConfig The default config for the instance
 */
function Axios(instanceConfig) {
  this.defaults = instanceConfig;
  this.interceptors = {
    request: new InterceptorManager(),
    response: new InterceptorManager()
  };
}

/**
 * Dispatch a request
 *
 * @param {Object} config The config specific for this request (merged with this.defaults)
 */
Axios.prototype.request = function request(config) {
  /*eslint no-param-reassign:0*/
  // Allow for axios('example/url'[, config]) a la fetch API
  if (typeof config === 'string') {
    config = arguments[1] || {};
    config.url = arguments[0];
  } else {
    config = config || {};
  }

  config = mergeConfig(this.defaults, config);
  config.method = config.method ? config.method.toLowerCase() : 'get';

  // Hook up interceptors middleware
  var chain = [dispatchRequest, undefined];
  var promise = Promise.resolve(config);

  this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
    chain.unshift(interceptor.fulfilled, interceptor.rejected);
  });

  this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
    chain.push(interceptor.fulfilled, interceptor.rejected);
  });

  while (chain.length) {
    promise = promise.then(chain.shift(), chain.shift());
  }

  return promise;
};

Axios.prototype.getUri = function getUri(config) {
  config = mergeConfig(this.defaults, config);
  return buildURL(config.url, config.params, config.paramsSerializer).replace(/^\?/, '');
};

// Provide aliases for supported request methods
utils.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, config) {
    return this.request(utils.merge(config || {}, {
      method: method,
      url: url
    }));
  };
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, data, config) {
    return this.request(utils.merge(config || {}, {
      method: method,
      url: url,
      data: data
    }));
  };
});

module.exports = Axios;


/***/ }),

/***/ "./node_modules/axios/lib/core/InterceptorManager.js":
/*!***********************************************************!*\
  !*** ./node_modules/axios/lib/core/InterceptorManager.js ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

function InterceptorManager() {
  this.handlers = [];
}

/**
 * Add a new interceptor to the stack
 *
 * @param {Function} fulfilled The function to handle `then` for a `Promise`
 * @param {Function} rejected The function to handle `reject` for a `Promise`
 *
 * @return {Number} An ID used to remove interceptor later
 */
InterceptorManager.prototype.use = function use(fulfilled, rejected) {
  this.handlers.push({
    fulfilled: fulfilled,
    rejected: rejected
  });
  return this.handlers.length - 1;
};

/**
 * Remove an interceptor from the stack
 *
 * @param {Number} id The ID that was returned by `use`
 */
InterceptorManager.prototype.eject = function eject(id) {
  if (this.handlers[id]) {
    this.handlers[id] = null;
  }
};

/**
 * Iterate over all the registered interceptors
 *
 * This method is particularly useful for skipping over any
 * interceptors that may have become `null` calling `eject`.
 *
 * @param {Function} fn The function to call for each interceptor
 */
InterceptorManager.prototype.forEach = function forEach(fn) {
  utils.forEach(this.handlers, function forEachHandler(h) {
    if (h !== null) {
      fn(h);
    }
  });
};

module.exports = InterceptorManager;


/***/ }),

/***/ "./node_modules/axios/lib/core/createError.js":
/*!****************************************************!*\
  !*** ./node_modules/axios/lib/core/createError.js ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var enhanceError = __webpack_require__(/*! ./enhanceError */ "./node_modules/axios/lib/core/enhanceError.js");

/**
 * Create an Error with the specified message, config, error code, request and response.
 *
 * @param {string} message The error message.
 * @param {Object} config The config.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The created error.
 */
module.exports = function createError(message, config, code, request, response) {
  var error = new Error(message);
  return enhanceError(error, config, code, request, response);
};


/***/ }),

/***/ "./node_modules/axios/lib/core/dispatchRequest.js":
/*!********************************************************!*\
  !*** ./node_modules/axios/lib/core/dispatchRequest.js ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");
var transformData = __webpack_require__(/*! ./transformData */ "./node_modules/axios/lib/core/transformData.js");
var isCancel = __webpack_require__(/*! ../cancel/isCancel */ "./node_modules/axios/lib/cancel/isCancel.js");
var defaults = __webpack_require__(/*! ../defaults */ "./node_modules/axios/lib/defaults.js");
var isAbsoluteURL = __webpack_require__(/*! ./../helpers/isAbsoluteURL */ "./node_modules/axios/lib/helpers/isAbsoluteURL.js");
var combineURLs = __webpack_require__(/*! ./../helpers/combineURLs */ "./node_modules/axios/lib/helpers/combineURLs.js");

/**
 * Throws a `Cancel` if cancellation has been requested.
 */
function throwIfCancellationRequested(config) {
  if (config.cancelToken) {
    config.cancelToken.throwIfRequested();
  }
}

/**
 * Dispatch a request to the server using the configured adapter.
 *
 * @param {object} config The config that is to be used for the request
 * @returns {Promise} The Promise to be fulfilled
 */
module.exports = function dispatchRequest(config) {
  throwIfCancellationRequested(config);

  // Support baseURL config
  if (config.baseURL && !isAbsoluteURL(config.url)) {
    config.url = combineURLs(config.baseURL, config.url);
  }

  // Ensure headers exist
  config.headers = config.headers || {};

  // Transform request data
  config.data = transformData(
    config.data,
    config.headers,
    config.transformRequest
  );

  // Flatten headers
  config.headers = utils.merge(
    config.headers.common || {},
    config.headers[config.method] || {},
    config.headers || {}
  );

  utils.forEach(
    ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
    function cleanHeaderConfig(method) {
      delete config.headers[method];
    }
  );

  var adapter = config.adapter || defaults.adapter;

  return adapter(config).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config);

    // Transform response data
    response.data = transformData(
      response.data,
      response.headers,
      config.transformResponse
    );

    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel(reason)) {
      throwIfCancellationRequested(config);

      // Transform response data
      if (reason && reason.response) {
        reason.response.data = transformData(
          reason.response.data,
          reason.response.headers,
          config.transformResponse
        );
      }
    }

    return Promise.reject(reason);
  });
};


/***/ }),

/***/ "./node_modules/axios/lib/core/enhanceError.js":
/*!*****************************************************!*\
  !*** ./node_modules/axios/lib/core/enhanceError.js ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Update an Error with the specified config, error code, and response.
 *
 * @param {Error} error The error to update.
 * @param {Object} config The config.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The error.
 */
module.exports = function enhanceError(error, config, code, request, response) {
  error.config = config;
  if (code) {
    error.code = code;
  }

  error.request = request;
  error.response = response;
  error.isAxiosError = true;

  error.toJSON = function() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: this.config,
      code: this.code
    };
  };
  return error;
};


/***/ }),

/***/ "./node_modules/axios/lib/core/mergeConfig.js":
/*!****************************************************!*\
  !*** ./node_modules/axios/lib/core/mergeConfig.js ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/axios/lib/utils.js");

/**
 * Config-specific merge-function which creates a new config-object
 * by merging two configuration objects together.
 *
 * @param {Object} config1
 * @param {Object} config2
 * @returns {Object} New object resulting from merging config2 to config1
 */
module.exports = function mergeConfig(config1, config2) {
  // eslint-disable-next-line no-param-reassign
  config2 = config2 || {};
  var config = {};

  utils.forEach(['url', 'method', 'params', 'data'], function valueFromConfig2(prop) {
    if (typeof config2[prop] !== 'undefined') {
      config[prop] = config2[prop];
    }
  });

  utils.forEach(['headers', 'auth', 'proxy'], function mergeDeepProperties(prop) {
    if (utils.isObject(config2[prop])) {
      config[prop] = utils.deepMerge(config1[prop], config2[prop]);
    } else if (typeof config2[prop] !== 'undefined') {
      config[prop] = config2[prop];
    } else if (utils.isObject(config1[prop])) {
      config[prop] = utils.deepMerge(config1[prop]);
    } else if (typeof config1[prop] !== 'undefined') {
      config[prop] = config1[prop];
    }
  });

  utils.forEach([
    'baseURL', 'transformRequest', 'transformResponse', 'paramsSerializer',
    'timeout', 'withCredentials', 'adapter', 'responseType', 'xsrfCookieName',
    'xsrfHeaderName', 'onUploadProgress', 'onDownloadProgress', 'maxContentLength',
    'validateStatus', 'maxRedirects', 'httpAgent', 'httpsAgent', 'cancelToken',
    'socketPath'
  ], function defaultToConfig2(prop) {
    if (typeof config2[prop] !== 'undefined') {
      config[prop] = config2[prop];
    } else if (typeof config1[prop] !== 'undefined') {
      config[prop] = config1[prop];
    }
  });

  return config;
};


/***/ }),

/***/ "./node_modules/axios/lib/core/settle.js":
/*!***********************************************!*\
  !*** ./node_modules/axios/lib/core/settle.js ***!
  \***********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var createError = __webpack_require__(/*! ./createError */ "./node_modules/axios/lib/core/createError.js");

/**
 * Resolve or reject a Promise based on response status.
 *
 * @param {Function} resolve A function that resolves the promise.
 * @param {Function} reject A function that rejects the promise.
 * @param {object} response The response.
 */
module.exports = function settle(resolve, reject, response) {
  var validateStatus = response.config.validateStatus;
  if (!validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(createError(
      'Request failed with status code ' + response.status,
      response.config,
      null,
      response.request,
      response
    ));
  }
};


/***/ }),

/***/ "./node_modules/axios/lib/core/transformData.js":
/*!******************************************************!*\
  !*** ./node_modules/axios/lib/core/transformData.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

/**
 * Transform the data for a request or a response
 *
 * @param {Object|String} data The data to be transformed
 * @param {Array} headers The headers for the request or response
 * @param {Array|Function} fns A single function or Array of functions
 * @returns {*} The resulting transformed data
 */
module.exports = function transformData(data, headers, fns) {
  /*eslint no-param-reassign:0*/
  utils.forEach(fns, function transform(fn) {
    data = fn(data, headers);
  });

  return data;
};


/***/ }),

/***/ "./node_modules/axios/lib/defaults.js":
/*!********************************************!*\
  !*** ./node_modules/axios/lib/defaults.js ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {

var utils = __webpack_require__(/*! ./utils */ "./node_modules/axios/lib/utils.js");
var normalizeHeaderName = __webpack_require__(/*! ./helpers/normalizeHeaderName */ "./node_modules/axios/lib/helpers/normalizeHeaderName.js");

var DEFAULT_CONTENT_TYPE = {
  'Content-Type': 'application/x-www-form-urlencoded'
};

function setContentTypeIfUnset(headers, value) {
  if (!utils.isUndefined(headers) && utils.isUndefined(headers['Content-Type'])) {
    headers['Content-Type'] = value;
  }
}

function getDefaultAdapter() {
  var adapter;
  // Only Node.JS has a process variable that is of [[Class]] process
  if (typeof process !== 'undefined' && Object.prototype.toString.call(process) === '[object process]') {
    // For node use HTTP adapter
    adapter = __webpack_require__(/*! ./adapters/http */ "./node_modules/axios/lib/adapters/xhr.js");
  } else if (typeof XMLHttpRequest !== 'undefined') {
    // For browsers use XHR adapter
    adapter = __webpack_require__(/*! ./adapters/xhr */ "./node_modules/axios/lib/adapters/xhr.js");
  }
  return adapter;
}

var defaults = {
  adapter: getDefaultAdapter(),

  transformRequest: [function transformRequest(data, headers) {
    normalizeHeaderName(headers, 'Accept');
    normalizeHeaderName(headers, 'Content-Type');
    if (utils.isFormData(data) ||
      utils.isArrayBuffer(data) ||
      utils.isBuffer(data) ||
      utils.isStream(data) ||
      utils.isFile(data) ||
      utils.isBlob(data)
    ) {
      return data;
    }
    if (utils.isArrayBufferView(data)) {
      return data.buffer;
    }
    if (utils.isURLSearchParams(data)) {
      setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
      return data.toString();
    }
    if (utils.isObject(data)) {
      setContentTypeIfUnset(headers, 'application/json;charset=utf-8');
      return JSON.stringify(data);
    }
    return data;
  }],

  transformResponse: [function transformResponse(data) {
    /*eslint no-param-reassign:0*/
    if (typeof data === 'string') {
      try {
        data = JSON.parse(data);
      } catch (e) { /* Ignore */ }
    }
    return data;
  }],

  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,

  xsrfCookieName: 'XSRF-TOKEN',
  xsrfHeaderName: 'X-XSRF-TOKEN',

  maxContentLength: -1,

  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  }
};

defaults.headers = {
  common: {
    'Accept': 'application/json, text/plain, */*'
  }
};

utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
  defaults.headers[method] = {};
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
});

module.exports = defaults;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../process/browser.js */ "./node_modules/process/browser.js")))

/***/ }),

/***/ "./node_modules/axios/lib/helpers/bind.js":
/*!************************************************!*\
  !*** ./node_modules/axios/lib/helpers/bind.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = function bind(fn, thisArg) {
  return function wrap() {
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    return fn.apply(thisArg, args);
  };
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/buildURL.js":
/*!****************************************************!*\
  !*** ./node_modules/axios/lib/helpers/buildURL.js ***!
  \****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

function encode(val) {
  return encodeURIComponent(val).
    replace(/%40/gi, '@').
    replace(/%3A/gi, ':').
    replace(/%24/g, '$').
    replace(/%2C/gi, ',').
    replace(/%20/g, '+').
    replace(/%5B/gi, '[').
    replace(/%5D/gi, ']');
}

/**
 * Build a URL by appending params to the end
 *
 * @param {string} url The base of the url (e.g., http://www.google.com)
 * @param {object} [params] The params to be appended
 * @returns {string} The formatted url
 */
module.exports = function buildURL(url, params, paramsSerializer) {
  /*eslint no-param-reassign:0*/
  if (!params) {
    return url;
  }

  var serializedParams;
  if (paramsSerializer) {
    serializedParams = paramsSerializer(params);
  } else if (utils.isURLSearchParams(params)) {
    serializedParams = params.toString();
  } else {
    var parts = [];

    utils.forEach(params, function serialize(val, key) {
      if (val === null || typeof val === 'undefined') {
        return;
      }

      if (utils.isArray(val)) {
        key = key + '[]';
      } else {
        val = [val];
      }

      utils.forEach(val, function parseValue(v) {
        if (utils.isDate(v)) {
          v = v.toISOString();
        } else if (utils.isObject(v)) {
          v = JSON.stringify(v);
        }
        parts.push(encode(key) + '=' + encode(v));
      });
    });

    serializedParams = parts.join('&');
  }

  if (serializedParams) {
    var hashmarkIndex = url.indexOf('#');
    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }

    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
  }

  return url;
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/combineURLs.js":
/*!*******************************************************!*\
  !*** ./node_modules/axios/lib/helpers/combineURLs.js ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Creates a new URL by combining the specified URLs
 *
 * @param {string} baseURL The base URL
 * @param {string} relativeURL The relative URL
 * @returns {string} The combined URL
 */
module.exports = function combineURLs(baseURL, relativeURL) {
  return relativeURL
    ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '')
    : baseURL;
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/cookies.js":
/*!***************************************************!*\
  !*** ./node_modules/axios/lib/helpers/cookies.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs support document.cookie
    (function standardBrowserEnv() {
      return {
        write: function write(name, value, expires, path, domain, secure) {
          var cookie = [];
          cookie.push(name + '=' + encodeURIComponent(value));

          if (utils.isNumber(expires)) {
            cookie.push('expires=' + new Date(expires).toGMTString());
          }

          if (utils.isString(path)) {
            cookie.push('path=' + path);
          }

          if (utils.isString(domain)) {
            cookie.push('domain=' + domain);
          }

          if (secure === true) {
            cookie.push('secure');
          }

          document.cookie = cookie.join('; ');
        },

        read: function read(name) {
          var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
          return (match ? decodeURIComponent(match[3]) : null);
        },

        remove: function remove(name) {
          this.write(name, '', Date.now() - 86400000);
        }
      };
    })() :

  // Non standard browser env (web workers, react-native) lack needed support.
    (function nonStandardBrowserEnv() {
      return {
        write: function write() {},
        read: function read() { return null; },
        remove: function remove() {}
      };
    })()
);


/***/ }),

/***/ "./node_modules/axios/lib/helpers/isAbsoluteURL.js":
/*!*********************************************************!*\
  !*** ./node_modules/axios/lib/helpers/isAbsoluteURL.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Determines whether the specified URL is absolute
 *
 * @param {string} url The URL to test
 * @returns {boolean} True if the specified URL is absolute, otherwise false
 */
module.exports = function isAbsoluteURL(url) {
  // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
  // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
  // by any combination of letters, digits, plus, period, or hyphen.
  return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/isURLSameOrigin.js":
/*!***********************************************************!*\
  !*** ./node_modules/axios/lib/helpers/isURLSameOrigin.js ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
    (function standardBrowserEnv() {
      var msie = /(msie|trident)/i.test(navigator.userAgent);
      var urlParsingNode = document.createElement('a');
      var originURL;

      /**
    * Parse a URL to discover it's components
    *
    * @param {String} url The URL to be parsed
    * @returns {Object}
    */
      function resolveURL(url) {
        var href = url;

        if (msie) {
        // IE needs attribute set twice to normalize properties
          urlParsingNode.setAttribute('href', href);
          href = urlParsingNode.href;
        }

        urlParsingNode.setAttribute('href', href);

        // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
        return {
          href: urlParsingNode.href,
          protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
          host: urlParsingNode.host,
          search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
          hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
          hostname: urlParsingNode.hostname,
          port: urlParsingNode.port,
          pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
            urlParsingNode.pathname :
            '/' + urlParsingNode.pathname
        };
      }

      originURL = resolveURL(window.location.href);

      /**
    * Determine if a URL shares the same origin as the current location
    *
    * @param {String} requestURL The URL to test
    * @returns {boolean} True if URL shares the same origin, otherwise false
    */
      return function isURLSameOrigin(requestURL) {
        var parsed = (utils.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
        return (parsed.protocol === originURL.protocol &&
            parsed.host === originURL.host);
      };
    })() :

  // Non standard browser envs (web workers, react-native) lack needed support.
    (function nonStandardBrowserEnv() {
      return function isURLSameOrigin() {
        return true;
      };
    })()
);


/***/ }),

/***/ "./node_modules/axios/lib/helpers/normalizeHeaderName.js":
/*!***************************************************************!*\
  !*** ./node_modules/axios/lib/helpers/normalizeHeaderName.js ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/axios/lib/utils.js");

module.exports = function normalizeHeaderName(headers, normalizedName) {
  utils.forEach(headers, function processHeader(value, name) {
    if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
      headers[normalizedName] = value;
      delete headers[name];
    }
  });
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/parseHeaders.js":
/*!********************************************************!*\
  !*** ./node_modules/axios/lib/helpers/parseHeaders.js ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./../utils */ "./node_modules/axios/lib/utils.js");

// Headers whose duplicates are ignored by node
// c.f. https://nodejs.org/api/http.html#http_message_headers
var ignoreDuplicateOf = [
  'age', 'authorization', 'content-length', 'content-type', 'etag',
  'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
  'last-modified', 'location', 'max-forwards', 'proxy-authorization',
  'referer', 'retry-after', 'user-agent'
];

/**
 * Parse headers into an object
 *
 * ```
 * Date: Wed, 27 Aug 2014 08:58:49 GMT
 * Content-Type: application/json
 * Connection: keep-alive
 * Transfer-Encoding: chunked
 * ```
 *
 * @param {String} headers Headers needing to be parsed
 * @returns {Object} Headers parsed into an object
 */
module.exports = function parseHeaders(headers) {
  var parsed = {};
  var key;
  var val;
  var i;

  if (!headers) { return parsed; }

  utils.forEach(headers.split('\n'), function parser(line) {
    i = line.indexOf(':');
    key = utils.trim(line.substr(0, i)).toLowerCase();
    val = utils.trim(line.substr(i + 1));

    if (key) {
      if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
        return;
      }
      if (key === 'set-cookie') {
        parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
      } else {
        parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
      }
    }
  });

  return parsed;
};


/***/ }),

/***/ "./node_modules/axios/lib/helpers/spread.js":
/*!**************************************************!*\
  !*** ./node_modules/axios/lib/helpers/spread.js ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Syntactic sugar for invoking a function and expanding an array for arguments.
 *
 * Common use case would be to use `Function.prototype.apply`.
 *
 *  ```js
 *  function f(x, y, z) {}
 *  var args = [1, 2, 3];
 *  f.apply(null, args);
 *  ```
 *
 * With `spread` this example can be re-written.
 *
 *  ```js
 *  spread(function(x, y, z) {})([1, 2, 3]);
 *  ```
 *
 * @param {Function} callback
 * @returns {Function}
 */
module.exports = function spread(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
};


/***/ }),

/***/ "./node_modules/axios/lib/utils.js":
/*!*****************************************!*\
  !*** ./node_modules/axios/lib/utils.js ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var bind = __webpack_require__(/*! ./helpers/bind */ "./node_modules/axios/lib/helpers/bind.js");
var isBuffer = __webpack_require__(/*! is-buffer */ "./node_modules/axios/node_modules/is-buffer/index.js");

/*global toString:true*/

// utils is a library of generic helper functions non-specific to axios

var toString = Object.prototype.toString;

/**
 * Determine if a value is an Array
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Array, otherwise false
 */
function isArray(val) {
  return toString.call(val) === '[object Array]';
}

/**
 * Determine if a value is an ArrayBuffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an ArrayBuffer, otherwise false
 */
function isArrayBuffer(val) {
  return toString.call(val) === '[object ArrayBuffer]';
}

/**
 * Determine if a value is a FormData
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an FormData, otherwise false
 */
function isFormData(val) {
  return (typeof FormData !== 'undefined') && (val instanceof FormData);
}

/**
 * Determine if a value is a view on an ArrayBuffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
 */
function isArrayBufferView(val) {
  var result;
  if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
    result = ArrayBuffer.isView(val);
  } else {
    result = (val) && (val.buffer) && (val.buffer instanceof ArrayBuffer);
  }
  return result;
}

/**
 * Determine if a value is a String
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a String, otherwise false
 */
function isString(val) {
  return typeof val === 'string';
}

/**
 * Determine if a value is a Number
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Number, otherwise false
 */
function isNumber(val) {
  return typeof val === 'number';
}

/**
 * Determine if a value is undefined
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if the value is undefined, otherwise false
 */
function isUndefined(val) {
  return typeof val === 'undefined';
}

/**
 * Determine if a value is an Object
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Object, otherwise false
 */
function isObject(val) {
  return val !== null && typeof val === 'object';
}

/**
 * Determine if a value is a Date
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Date, otherwise false
 */
function isDate(val) {
  return toString.call(val) === '[object Date]';
}

/**
 * Determine if a value is a File
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a File, otherwise false
 */
function isFile(val) {
  return toString.call(val) === '[object File]';
}

/**
 * Determine if a value is a Blob
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Blob, otherwise false
 */
function isBlob(val) {
  return toString.call(val) === '[object Blob]';
}

/**
 * Determine if a value is a Function
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Function, otherwise false
 */
function isFunction(val) {
  return toString.call(val) === '[object Function]';
}

/**
 * Determine if a value is a Stream
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Stream, otherwise false
 */
function isStream(val) {
  return isObject(val) && isFunction(val.pipe);
}

/**
 * Determine if a value is a URLSearchParams object
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a URLSearchParams object, otherwise false
 */
function isURLSearchParams(val) {
  return typeof URLSearchParams !== 'undefined' && val instanceof URLSearchParams;
}

/**
 * Trim excess whitespace off the beginning and end of a string
 *
 * @param {String} str The String to trim
 * @returns {String} The String freed of excess whitespace
 */
function trim(str) {
  return str.replace(/^\s*/, '').replace(/\s*$/, '');
}

/**
 * Determine if we're running in a standard browser environment
 *
 * This allows axios to run in a web worker, and react-native.
 * Both environments support XMLHttpRequest, but not fully standard globals.
 *
 * web workers:
 *  typeof window -> undefined
 *  typeof document -> undefined
 *
 * react-native:
 *  navigator.product -> 'ReactNative'
 * nativescript
 *  navigator.product -> 'NativeScript' or 'NS'
 */
function isStandardBrowserEnv() {
  if (typeof navigator !== 'undefined' && (navigator.product === 'ReactNative' ||
                                           navigator.product === 'NativeScript' ||
                                           navigator.product === 'NS')) {
    return false;
  }
  return (
    typeof window !== 'undefined' &&
    typeof document !== 'undefined'
  );
}

/**
 * Iterate over an Array or an Object invoking a function for each item.
 *
 * If `obj` is an Array callback will be called passing
 * the value, index, and complete array for each item.
 *
 * If 'obj' is an Object callback will be called passing
 * the value, key, and complete object for each property.
 *
 * @param {Object|Array} obj The object to iterate
 * @param {Function} fn The callback to invoke for each item
 */
function forEach(obj, fn) {
  // Don't bother if no value provided
  if (obj === null || typeof obj === 'undefined') {
    return;
  }

  // Force an array if not already something iterable
  if (typeof obj !== 'object') {
    /*eslint no-param-reassign:0*/
    obj = [obj];
  }

  if (isArray(obj)) {
    // Iterate over array values
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    // Iterate over object keys
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}

/**
 * Accepts varargs expecting each argument to be an object, then
 * immutably merges the properties of each object and returns result.
 *
 * When multiple objects contain the same key the later object in
 * the arguments list will take precedence.
 *
 * Example:
 *
 * ```js
 * var result = merge({foo: 123}, {foo: 456});
 * console.log(result.foo); // outputs 456
 * ```
 *
 * @param {Object} obj1 Object to merge
 * @returns {Object} Result of all merge properties
 */
function merge(/* obj1, obj2, obj3, ... */) {
  var result = {};
  function assignValue(val, key) {
    if (typeof result[key] === 'object' && typeof val === 'object') {
      result[key] = merge(result[key], val);
    } else {
      result[key] = val;
    }
  }

  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}

/**
 * Function equal to merge with the difference being that no reference
 * to original objects is kept.
 *
 * @see merge
 * @param {Object} obj1 Object to merge
 * @returns {Object} Result of all merge properties
 */
function deepMerge(/* obj1, obj2, obj3, ... */) {
  var result = {};
  function assignValue(val, key) {
    if (typeof result[key] === 'object' && typeof val === 'object') {
      result[key] = deepMerge(result[key], val);
    } else if (typeof val === 'object') {
      result[key] = deepMerge({}, val);
    } else {
      result[key] = val;
    }
  }

  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}

/**
 * Extends object a by mutably adding to it the properties of object b.
 *
 * @param {Object} a The object to be extended
 * @param {Object} b The object to copy properties from
 * @param {Object} thisArg The object to bind function to
 * @return {Object} The resulting value of object a
 */
function extend(a, b, thisArg) {
  forEach(b, function assignValue(val, key) {
    if (thisArg && typeof val === 'function') {
      a[key] = bind(val, thisArg);
    } else {
      a[key] = val;
    }
  });
  return a;
}

module.exports = {
  isArray: isArray,
  isArrayBuffer: isArrayBuffer,
  isBuffer: isBuffer,
  isFormData: isFormData,
  isArrayBufferView: isArrayBufferView,
  isString: isString,
  isNumber: isNumber,
  isObject: isObject,
  isUndefined: isUndefined,
  isDate: isDate,
  isFile: isFile,
  isBlob: isBlob,
  isFunction: isFunction,
  isStream: isStream,
  isURLSearchParams: isURLSearchParams,
  isStandardBrowserEnv: isStandardBrowserEnv,
  forEach: forEach,
  merge: merge,
  deepMerge: deepMerge,
  extend: extend,
  trim: trim
};


/***/ }),

/***/ "./node_modules/axios/node_modules/is-buffer/index.js":
/*!************************************************************!*\
  !*** ./node_modules/axios/node_modules/is-buffer/index.js ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

/*!
 * Determine if an object is a Buffer
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */

module.exports = function isBuffer (obj) {
  return obj != null && obj.constructor != null &&
    typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
}


/***/ }),

/***/ "./node_modules/es6-promise/dist/es6-promise.js":
/*!******************************************************!*\
  !*** ./node_modules/es6-promise/dist/es6-promise.js ***!
  \******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process, global) {/*!
 * @overview es6-promise - a tiny implementation of Promises/A+.
 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
 * @license   Licensed under MIT license
 *            See https://raw.githubusercontent.com/stefanpenner/es6-promise/master/LICENSE
 * @version   v4.2.8+1e68dce6
 */

(function (global, factory) {
	 true ? module.exports = factory() :
	undefined;
}(this, (function () { 'use strict';

function objectOrFunction(x) {
  var type = typeof x;
  return x !== null && (type === 'object' || type === 'function');
}

function isFunction(x) {
  return typeof x === 'function';
}



var _isArray = void 0;
if (Array.isArray) {
  _isArray = Array.isArray;
} else {
  _isArray = function (x) {
    return Object.prototype.toString.call(x) === '[object Array]';
  };
}

var isArray = _isArray;

var len = 0;
var vertxNext = void 0;
var customSchedulerFn = void 0;

var asap = function asap(callback, arg) {
  queue[len] = callback;
  queue[len + 1] = arg;
  len += 2;
  if (len === 2) {
    // If len is 2, that means that we need to schedule an async flush.
    // If additional callbacks are queued before the queue is flushed, they
    // will be processed by this flush that we are scheduling.
    if (customSchedulerFn) {
      customSchedulerFn(flush);
    } else {
      scheduleFlush();
    }
  }
};

function setScheduler(scheduleFn) {
  customSchedulerFn = scheduleFn;
}

function setAsap(asapFn) {
  asap = asapFn;
}

var browserWindow = typeof window !== 'undefined' ? window : undefined;
var browserGlobal = browserWindow || {};
var BrowserMutationObserver = browserGlobal.MutationObserver || browserGlobal.WebKitMutationObserver;
var isNode = typeof self === 'undefined' && typeof process !== 'undefined' && {}.toString.call(process) === '[object process]';

// test for web worker but not in IE10
var isWorker = typeof Uint8ClampedArray !== 'undefined' && typeof importScripts !== 'undefined' && typeof MessageChannel !== 'undefined';

// node
function useNextTick() {
  // node version 0.10.x displays a deprecation warning when nextTick is used recursively
  // see https://github.com/cujojs/when/issues/410 for details
  return function () {
    return process.nextTick(flush);
  };
}

// vertx
function useVertxTimer() {
  if (typeof vertxNext !== 'undefined') {
    return function () {
      vertxNext(flush);
    };
  }

  return useSetTimeout();
}

function useMutationObserver() {
  var iterations = 0;
  var observer = new BrowserMutationObserver(flush);
  var node = document.createTextNode('');
  observer.observe(node, { characterData: true });

  return function () {
    node.data = iterations = ++iterations % 2;
  };
}

// web worker
function useMessageChannel() {
  var channel = new MessageChannel();
  channel.port1.onmessage = flush;
  return function () {
    return channel.port2.postMessage(0);
  };
}

function useSetTimeout() {
  // Store setTimeout reference so es6-promise will be unaffected by
  // other code modifying setTimeout (like sinon.useFakeTimers())
  var globalSetTimeout = setTimeout;
  return function () {
    return globalSetTimeout(flush, 1);
  };
}

var queue = new Array(1000);
function flush() {
  for (var i = 0; i < len; i += 2) {
    var callback = queue[i];
    var arg = queue[i + 1];

    callback(arg);

    queue[i] = undefined;
    queue[i + 1] = undefined;
  }

  len = 0;
}

function attemptVertx() {
  try {
    var vertx = Function('return this')().require('vertx');
    vertxNext = vertx.runOnLoop || vertx.runOnContext;
    return useVertxTimer();
  } catch (e) {
    return useSetTimeout();
  }
}

var scheduleFlush = void 0;
// Decide what async method to use to triggering processing of queued callbacks:
if (isNode) {
  scheduleFlush = useNextTick();
} else if (BrowserMutationObserver) {
  scheduleFlush = useMutationObserver();
} else if (isWorker) {
  scheduleFlush = useMessageChannel();
} else if (browserWindow === undefined && "function" === 'function') {
  scheduleFlush = attemptVertx();
} else {
  scheduleFlush = useSetTimeout();
}

function then(onFulfillment, onRejection) {
  var parent = this;

  var child = new this.constructor(noop);

  if (child[PROMISE_ID] === undefined) {
    makePromise(child);
  }

  var _state = parent._state;


  if (_state) {
    var callback = arguments[_state - 1];
    asap(function () {
      return invokeCallback(_state, child, callback, parent._result);
    });
  } else {
    subscribe(parent, child, onFulfillment, onRejection);
  }

  return child;
}

/**
  `Promise.resolve` returns a promise that will become resolved with the
  passed `value`. It is shorthand for the following:

  ```javascript
  let promise = new Promise(function(resolve, reject){
    resolve(1);
  });

  promise.then(function(value){
    // value === 1
  });
  ```

  Instead of writing the above, your code now simply becomes the following:

  ```javascript
  let promise = Promise.resolve(1);

  promise.then(function(value){
    // value === 1
  });
  ```

  @method resolve
  @static
  @param {Any} value value that the returned promise will be resolved with
  Useful for tooling.
  @return {Promise} a promise that will become fulfilled with the given
  `value`
*/
function resolve$1(object) {
  /*jshint validthis:true */
  var Constructor = this;

  if (object && typeof object === 'object' && object.constructor === Constructor) {
    return object;
  }

  var promise = new Constructor(noop);
  resolve(promise, object);
  return promise;
}

var PROMISE_ID = Math.random().toString(36).substring(2);

function noop() {}

var PENDING = void 0;
var FULFILLED = 1;
var REJECTED = 2;

function selfFulfillment() {
  return new TypeError("You cannot resolve a promise with itself");
}

function cannotReturnOwn() {
  return new TypeError('A promises callback cannot return that same promise.');
}

function tryThen(then$$1, value, fulfillmentHandler, rejectionHandler) {
  try {
    then$$1.call(value, fulfillmentHandler, rejectionHandler);
  } catch (e) {
    return e;
  }
}

function handleForeignThenable(promise, thenable, then$$1) {
  asap(function (promise) {
    var sealed = false;
    var error = tryThen(then$$1, thenable, function (value) {
      if (sealed) {
        return;
      }
      sealed = true;
      if (thenable !== value) {
        resolve(promise, value);
      } else {
        fulfill(promise, value);
      }
    }, function (reason) {
      if (sealed) {
        return;
      }
      sealed = true;

      reject(promise, reason);
    }, 'Settle: ' + (promise._label || ' unknown promise'));

    if (!sealed && error) {
      sealed = true;
      reject(promise, error);
    }
  }, promise);
}

function handleOwnThenable(promise, thenable) {
  if (thenable._state === FULFILLED) {
    fulfill(promise, thenable._result);
  } else if (thenable._state === REJECTED) {
    reject(promise, thenable._result);
  } else {
    subscribe(thenable, undefined, function (value) {
      return resolve(promise, value);
    }, function (reason) {
      return reject(promise, reason);
    });
  }
}

function handleMaybeThenable(promise, maybeThenable, then$$1) {
  if (maybeThenable.constructor === promise.constructor && then$$1 === then && maybeThenable.constructor.resolve === resolve$1) {
    handleOwnThenable(promise, maybeThenable);
  } else {
    if (then$$1 === undefined) {
      fulfill(promise, maybeThenable);
    } else if (isFunction(then$$1)) {
      handleForeignThenable(promise, maybeThenable, then$$1);
    } else {
      fulfill(promise, maybeThenable);
    }
  }
}

function resolve(promise, value) {
  if (promise === value) {
    reject(promise, selfFulfillment());
  } else if (objectOrFunction(value)) {
    var then$$1 = void 0;
    try {
      then$$1 = value.then;
    } catch (error) {
      reject(promise, error);
      return;
    }
    handleMaybeThenable(promise, value, then$$1);
  } else {
    fulfill(promise, value);
  }
}

function publishRejection(promise) {
  if (promise._onerror) {
    promise._onerror(promise._result);
  }

  publish(promise);
}

function fulfill(promise, value) {
  if (promise._state !== PENDING) {
    return;
  }

  promise._result = value;
  promise._state = FULFILLED;

  if (promise._subscribers.length !== 0) {
    asap(publish, promise);
  }
}

function reject(promise, reason) {
  if (promise._state !== PENDING) {
    return;
  }
  promise._state = REJECTED;
  promise._result = reason;

  asap(publishRejection, promise);
}

function subscribe(parent, child, onFulfillment, onRejection) {
  var _subscribers = parent._subscribers;
  var length = _subscribers.length;


  parent._onerror = null;

  _subscribers[length] = child;
  _subscribers[length + FULFILLED] = onFulfillment;
  _subscribers[length + REJECTED] = onRejection;

  if (length === 0 && parent._state) {
    asap(publish, parent);
  }
}

function publish(promise) {
  var subscribers = promise._subscribers;
  var settled = promise._state;

  if (subscribers.length === 0) {
    return;
  }

  var child = void 0,
      callback = void 0,
      detail = promise._result;

  for (var i = 0; i < subscribers.length; i += 3) {
    child = subscribers[i];
    callback = subscribers[i + settled];

    if (child) {
      invokeCallback(settled, child, callback, detail);
    } else {
      callback(detail);
    }
  }

  promise._subscribers.length = 0;
}

function invokeCallback(settled, promise, callback, detail) {
  var hasCallback = isFunction(callback),
      value = void 0,
      error = void 0,
      succeeded = true;

  if (hasCallback) {
    try {
      value = callback(detail);
    } catch (e) {
      succeeded = false;
      error = e;
    }

    if (promise === value) {
      reject(promise, cannotReturnOwn());
      return;
    }
  } else {
    value = detail;
  }

  if (promise._state !== PENDING) {
    // noop
  } else if (hasCallback && succeeded) {
    resolve(promise, value);
  } else if (succeeded === false) {
    reject(promise, error);
  } else if (settled === FULFILLED) {
    fulfill(promise, value);
  } else if (settled === REJECTED) {
    reject(promise, value);
  }
}

function initializePromise(promise, resolver) {
  try {
    resolver(function resolvePromise(value) {
      resolve(promise, value);
    }, function rejectPromise(reason) {
      reject(promise, reason);
    });
  } catch (e) {
    reject(promise, e);
  }
}

var id = 0;
function nextId() {
  return id++;
}

function makePromise(promise) {
  promise[PROMISE_ID] = id++;
  promise._state = undefined;
  promise._result = undefined;
  promise._subscribers = [];
}

function validationError() {
  return new Error('Array Methods must be provided an Array');
}

var Enumerator = function () {
  function Enumerator(Constructor, input) {
    this._instanceConstructor = Constructor;
    this.promise = new Constructor(noop);

    if (!this.promise[PROMISE_ID]) {
      makePromise(this.promise);
    }

    if (isArray(input)) {
      this.length = input.length;
      this._remaining = input.length;

      this._result = new Array(this.length);

      if (this.length === 0) {
        fulfill(this.promise, this._result);
      } else {
        this.length = this.length || 0;
        this._enumerate(input);
        if (this._remaining === 0) {
          fulfill(this.promise, this._result);
        }
      }
    } else {
      reject(this.promise, validationError());
    }
  }

  Enumerator.prototype._enumerate = function _enumerate(input) {
    for (var i = 0; this._state === PENDING && i < input.length; i++) {
      this._eachEntry(input[i], i);
    }
  };

  Enumerator.prototype._eachEntry = function _eachEntry(entry, i) {
    var c = this._instanceConstructor;
    var resolve$$1 = c.resolve;


    if (resolve$$1 === resolve$1) {
      var _then = void 0;
      var error = void 0;
      var didError = false;
      try {
        _then = entry.then;
      } catch (e) {
        didError = true;
        error = e;
      }

      if (_then === then && entry._state !== PENDING) {
        this._settledAt(entry._state, i, entry._result);
      } else if (typeof _then !== 'function') {
        this._remaining--;
        this._result[i] = entry;
      } else if (c === Promise$1) {
        var promise = new c(noop);
        if (didError) {
          reject(promise, error);
        } else {
          handleMaybeThenable(promise, entry, _then);
        }
        this._willSettleAt(promise, i);
      } else {
        this._willSettleAt(new c(function (resolve$$1) {
          return resolve$$1(entry);
        }), i);
      }
    } else {
      this._willSettleAt(resolve$$1(entry), i);
    }
  };

  Enumerator.prototype._settledAt = function _settledAt(state, i, value) {
    var promise = this.promise;


    if (promise._state === PENDING) {
      this._remaining--;

      if (state === REJECTED) {
        reject(promise, value);
      } else {
        this._result[i] = value;
      }
    }

    if (this._remaining === 0) {
      fulfill(promise, this._result);
    }
  };

  Enumerator.prototype._willSettleAt = function _willSettleAt(promise, i) {
    var enumerator = this;

    subscribe(promise, undefined, function (value) {
      return enumerator._settledAt(FULFILLED, i, value);
    }, function (reason) {
      return enumerator._settledAt(REJECTED, i, reason);
    });
  };

  return Enumerator;
}();

/**
  `Promise.all` accepts an array of promises, and returns a new promise which
  is fulfilled with an array of fulfillment values for the passed promises, or
  rejected with the reason of the first passed promise to be rejected. It casts all
  elements of the passed iterable to promises as it runs this algorithm.

  Example:

  ```javascript
  let promise1 = resolve(1);
  let promise2 = resolve(2);
  let promise3 = resolve(3);
  let promises = [ promise1, promise2, promise3 ];

  Promise.all(promises).then(function(array){
    // The array here would be [ 1, 2, 3 ];
  });
  ```

  If any of the `promises` given to `all` are rejected, the first promise
  that is rejected will be given as an argument to the returned promises's
  rejection handler. For example:

  Example:

  ```javascript
  let promise1 = resolve(1);
  let promise2 = reject(new Error("2"));
  let promise3 = reject(new Error("3"));
  let promises = [ promise1, promise2, promise3 ];

  Promise.all(promises).then(function(array){
    // Code here never runs because there are rejected promises!
  }, function(error) {
    // error.message === "2"
  });
  ```

  @method all
  @static
  @param {Array} entries array of promises
  @param {String} label optional string for labeling the promise.
  Useful for tooling.
  @return {Promise} promise that is fulfilled when all `promises` have been
  fulfilled, or rejected if any of them become rejected.
  @static
*/
function all(entries) {
  return new Enumerator(this, entries).promise;
}

/**
  `Promise.race` returns a new promise which is settled in the same way as the
  first passed promise to settle.

  Example:

  ```javascript
  let promise1 = new Promise(function(resolve, reject){
    setTimeout(function(){
      resolve('promise 1');
    }, 200);
  });

  let promise2 = new Promise(function(resolve, reject){
    setTimeout(function(){
      resolve('promise 2');
    }, 100);
  });

  Promise.race([promise1, promise2]).then(function(result){
    // result === 'promise 2' because it was resolved before promise1
    // was resolved.
  });
  ```

  `Promise.race` is deterministic in that only the state of the first
  settled promise matters. For example, even if other promises given to the
  `promises` array argument are resolved, but the first settled promise has
  become rejected before the other promises became fulfilled, the returned
  promise will become rejected:

  ```javascript
  let promise1 = new Promise(function(resolve, reject){
    setTimeout(function(){
      resolve('promise 1');
    }, 200);
  });

  let promise2 = new Promise(function(resolve, reject){
    setTimeout(function(){
      reject(new Error('promise 2'));
    }, 100);
  });

  Promise.race([promise1, promise2]).then(function(result){
    // Code here never runs
  }, function(reason){
    // reason.message === 'promise 2' because promise 2 became rejected before
    // promise 1 became fulfilled
  });
  ```

  An example real-world use case is implementing timeouts:

  ```javascript
  Promise.race([ajax('foo.json'), timeout(5000)])
  ```

  @method race
  @static
  @param {Array} promises array of promises to observe
  Useful for tooling.
  @return {Promise} a promise which settles in the same way as the first passed
  promise to settle.
*/
function race(entries) {
  /*jshint validthis:true */
  var Constructor = this;

  if (!isArray(entries)) {
    return new Constructor(function (_, reject) {
      return reject(new TypeError('You must pass an array to race.'));
    });
  } else {
    return new Constructor(function (resolve, reject) {
      var length = entries.length;
      for (var i = 0; i < length; i++) {
        Constructor.resolve(entries[i]).then(resolve, reject);
      }
    });
  }
}

/**
  `Promise.reject` returns a promise rejected with the passed `reason`.
  It is shorthand for the following:

  ```javascript
  let promise = new Promise(function(resolve, reject){
    reject(new Error('WHOOPS'));
  });

  promise.then(function(value){
    // Code here doesn't run because the promise is rejected!
  }, function(reason){
    // reason.message === 'WHOOPS'
  });
  ```

  Instead of writing the above, your code now simply becomes the following:

  ```javascript
  let promise = Promise.reject(new Error('WHOOPS'));

  promise.then(function(value){
    // Code here doesn't run because the promise is rejected!
  }, function(reason){
    // reason.message === 'WHOOPS'
  });
  ```

  @method reject
  @static
  @param {Any} reason value that the returned promise will be rejected with.
  Useful for tooling.
  @return {Promise} a promise rejected with the given `reason`.
*/
function reject$1(reason) {
  /*jshint validthis:true */
  var Constructor = this;
  var promise = new Constructor(noop);
  reject(promise, reason);
  return promise;
}

function needsResolver() {
  throw new TypeError('You must pass a resolver function as the first argument to the promise constructor');
}

function needsNew() {
  throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");
}

/**
  Promise objects represent the eventual result of an asynchronous operation. The
  primary way of interacting with a promise is through its `then` method, which
  registers callbacks to receive either a promise's eventual value or the reason
  why the promise cannot be fulfilled.

  Terminology
  -----------

  - `promise` is an object or function with a `then` method whose behavior conforms to this specification.
  - `thenable` is an object or function that defines a `then` method.
  - `value` is any legal JavaScript value (including undefined, a thenable, or a promise).
  - `exception` is a value that is thrown using the throw statement.
  - `reason` is a value that indicates why a promise was rejected.
  - `settled` the final resting state of a promise, fulfilled or rejected.

  A promise can be in one of three states: pending, fulfilled, or rejected.

  Promises that are fulfilled have a fulfillment value and are in the fulfilled
  state.  Promises that are rejected have a rejection reason and are in the
  rejected state.  A fulfillment value is never a thenable.

  Promises can also be said to *resolve* a value.  If this value is also a
  promise, then the original promise's settled state will match the value's
  settled state.  So a promise that *resolves* a promise that rejects will
  itself reject, and a promise that *resolves* a promise that fulfills will
  itself fulfill.


  Basic Usage:
  ------------

  ```js
  let promise = new Promise(function(resolve, reject) {
    // on success
    resolve(value);

    // on failure
    reject(reason);
  });

  promise.then(function(value) {
    // on fulfillment
  }, function(reason) {
    // on rejection
  });
  ```

  Advanced Usage:
  ---------------

  Promises shine when abstracting away asynchronous interactions such as
  `XMLHttpRequest`s.

  ```js
  function getJSON(url) {
    return new Promise(function(resolve, reject){
      let xhr = new XMLHttpRequest();

      xhr.open('GET', url);
      xhr.onreadystatechange = handler;
      xhr.responseType = 'json';
      xhr.setRequestHeader('Accept', 'application/json');
      xhr.send();

      function handler() {
        if (this.readyState === this.DONE) {
          if (this.status === 200) {
            resolve(this.response);
          } else {
            reject(new Error('getJSON: `' + url + '` failed with status: [' + this.status + ']'));
          }
        }
      };
    });
  }

  getJSON('/posts.json').then(function(json) {
    // on fulfillment
  }, function(reason) {
    // on rejection
  });
  ```

  Unlike callbacks, promises are great composable primitives.

  ```js
  Promise.all([
    getJSON('/posts'),
    getJSON('/comments')
  ]).then(function(values){
    values[0] // => postsJSON
    values[1] // => commentsJSON

    return values;
  });
  ```

  @class Promise
  @param {Function} resolver
  Useful for tooling.
  @constructor
*/

var Promise$1 = function () {
  function Promise(resolver) {
    this[PROMISE_ID] = nextId();
    this._result = this._state = undefined;
    this._subscribers = [];

    if (noop !== resolver) {
      typeof resolver !== 'function' && needsResolver();
      this instanceof Promise ? initializePromise(this, resolver) : needsNew();
    }
  }

  /**
  The primary way of interacting with a promise is through its `then` method,
  which registers callbacks to receive either a promise's eventual value or the
  reason why the promise cannot be fulfilled.
   ```js
  findUser().then(function(user){
    // user is available
  }, function(reason){
    // user is unavailable, and you are given the reason why
  });
  ```
   Chaining
  --------
   The return value of `then` is itself a promise.  This second, 'downstream'
  promise is resolved with the return value of the first promise's fulfillment
  or rejection handler, or rejected if the handler throws an exception.
   ```js
  findUser().then(function (user) {
    return user.name;
  }, function (reason) {
    return 'default name';
  }).then(function (userName) {
    // If `findUser` fulfilled, `userName` will be the user's name, otherwise it
    // will be `'default name'`
  });
   findUser().then(function (user) {
    throw new Error('Found user, but still unhappy');
  }, function (reason) {
    throw new Error('`findUser` rejected and we're unhappy');
  }).then(function (value) {
    // never reached
  }, function (reason) {
    // if `findUser` fulfilled, `reason` will be 'Found user, but still unhappy'.
    // If `findUser` rejected, `reason` will be '`findUser` rejected and we're unhappy'.
  });
  ```
  If the downstream promise does not specify a rejection handler, rejection reasons will be propagated further downstream.
   ```js
  findUser().then(function (user) {
    throw new PedagogicalException('Upstream error');
  }).then(function (value) {
    // never reached
  }).then(function (value) {
    // never reached
  }, function (reason) {
    // The `PedgagocialException` is propagated all the way down to here
  });
  ```
   Assimilation
  ------------
   Sometimes the value you want to propagate to a downstream promise can only be
  retrieved asynchronously. This can be achieved by returning a promise in the
  fulfillment or rejection handler. The downstream promise will then be pending
  until the returned promise is settled. This is called *assimilation*.
   ```js
  findUser().then(function (user) {
    return findCommentsByAuthor(user);
  }).then(function (comments) {
    // The user's comments are now available
  });
  ```
   If the assimliated promise rejects, then the downstream promise will also reject.
   ```js
  findUser().then(function (user) {
    return findCommentsByAuthor(user);
  }).then(function (comments) {
    // If `findCommentsByAuthor` fulfills, we'll have the value here
  }, function (reason) {
    // If `findCommentsByAuthor` rejects, we'll have the reason here
  });
  ```
   Simple Example
  --------------
   Synchronous Example
   ```javascript
  let result;
   try {
    result = findResult();
    // success
  } catch(reason) {
    // failure
  }
  ```
   Errback Example
   ```js
  findResult(function(result, err){
    if (err) {
      // failure
    } else {
      // success
    }
  });
  ```
   Promise Example;
   ```javascript
  findResult().then(function(result){
    // success
  }, function(reason){
    // failure
  });
  ```
   Advanced Example
  --------------
   Synchronous Example
   ```javascript
  let author, books;
   try {
    author = findAuthor();
    books  = findBooksByAuthor(author);
    // success
  } catch(reason) {
    // failure
  }
  ```
   Errback Example
   ```js
   function foundBooks(books) {
   }
   function failure(reason) {
   }
   findAuthor(function(author, err){
    if (err) {
      failure(err);
      // failure
    } else {
      try {
        findBoooksByAuthor(author, function(books, err) {
          if (err) {
            failure(err);
          } else {
            try {
              foundBooks(books);
            } catch(reason) {
              failure(reason);
            }
          }
        });
      } catch(error) {
        failure(err);
      }
      // success
    }
  });
  ```
   Promise Example;
   ```javascript
  findAuthor().
    then(findBooksByAuthor).
    then(function(books){
      // found books
  }).catch(function(reason){
    // something went wrong
  });
  ```
   @method then
  @param {Function} onFulfilled
  @param {Function} onRejected
  Useful for tooling.
  @return {Promise}
  */

  /**
  `catch` is simply sugar for `then(undefined, onRejection)` which makes it the same
  as the catch block of a try/catch statement.
  ```js
  function findAuthor(){
  throw new Error('couldn't find that author');
  }
  // synchronous
  try {
  findAuthor();
  } catch(reason) {
  // something went wrong
  }
  // async with promises
  findAuthor().catch(function(reason){
  // something went wrong
  });
  ```
  @method catch
  @param {Function} onRejection
  Useful for tooling.
  @return {Promise}
  */


  Promise.prototype.catch = function _catch(onRejection) {
    return this.then(null, onRejection);
  };

  /**
    `finally` will be invoked regardless of the promise's fate just as native
    try/catch/finally behaves
  
    Synchronous example:
  
    ```js
    findAuthor() {
      if (Math.random() > 0.5) {
        throw new Error();
      }
      return new Author();
    }
  
    try {
      return findAuthor(); // succeed or fail
    } catch(error) {
      return findOtherAuther();
    } finally {
      // always runs
      // doesn't affect the return value
    }
    ```
  
    Asynchronous example:
  
    ```js
    findAuthor().catch(function(reason){
      return findOtherAuther();
    }).finally(function(){
      // author was either found, or not
    });
    ```
  
    @method finally
    @param {Function} callback
    @return {Promise}
  */


  Promise.prototype.finally = function _finally(callback) {
    var promise = this;
    var constructor = promise.constructor;

    if (isFunction(callback)) {
      return promise.then(function (value) {
        return constructor.resolve(callback()).then(function () {
          return value;
        });
      }, function (reason) {
        return constructor.resolve(callback()).then(function () {
          throw reason;
        });
      });
    }

    return promise.then(callback, callback);
  };

  return Promise;
}();

Promise$1.prototype.then = then;
Promise$1.all = all;
Promise$1.race = race;
Promise$1.resolve = resolve$1;
Promise$1.reject = reject$1;
Promise$1._setScheduler = setScheduler;
Promise$1._setAsap = setAsap;
Promise$1._asap = asap;

/*global self*/
function polyfill() {
  var local = void 0;

  if (typeof global !== 'undefined') {
    local = global;
  } else if (typeof self !== 'undefined') {
    local = self;
  } else {
    try {
      local = Function('return this')();
    } catch (e) {
      throw new Error('polyfill failed because global object is unavailable in this environment');
    }
  }

  var P = local.Promise;

  if (P) {
    var promiseToString = null;
    try {
      promiseToString = Object.prototype.toString.call(P.resolve());
    } catch (e) {
      // silently ignored
    }

    if (promiseToString === '[object Promise]' && !P.cast) {
      return;
    }
  }

  local.Promise = Promise$1;
}

// Strange compat..
Promise$1.polyfill = polyfill;
Promise$1.Promise = Promise$1;

return Promise$1;

})));



//# sourceMappingURL=es6-promise.map

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../process/browser.js */ "./node_modules/process/browser.js"), __webpack_require__(/*! ./../../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/isomorphic-fetch/fetch-npm-browserify.js":
/*!***************************************************************!*\
  !*** ./node_modules/isomorphic-fetch/fetch-npm-browserify.js ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

// the whatwg-fetch polyfill installs the fetch() function
// on the global object (window or self)
//
// Return that as the export for use in Webpack, Browserify etc.
__webpack_require__(/*! whatwg-fetch */ "./node_modules/whatwg-fetch/fetch.js");
module.exports = self.fetch.bind(self);


/***/ }),

/***/ "./node_modules/isomorphic-form-data/lib/browser.js":
/*!**********************************************************!*\
  !*** ./node_modules/isomorphic-form-data/lib/browser.js ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = window.FormData


/***/ }),

/***/ "./node_modules/process/browser.js":
/*!*****************************************!*\
  !*** ./node_modules/process/browser.js ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),

/***/ "./node_modules/tslib/tslib.es6.js":
/*!*****************************************!*\
  !*** ./node_modules/tslib/tslib.es6.js ***!
  \*****************************************/
/*! exports provided: __extends, __assign, __rest, __decorate, __param, __metadata, __awaiter, __generator, __exportStar, __values, __read, __spread, __spreadArrays, __await, __asyncGenerator, __asyncDelegator, __asyncValues, __makeTemplateObject, __importStar, __importDefault */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__extends", function() { return __extends; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__assign", function() { return __assign; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__rest", function() { return __rest; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__decorate", function() { return __decorate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__param", function() { return __param; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__metadata", function() { return __metadata; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__awaiter", function() { return __awaiter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__generator", function() { return __generator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__exportStar", function() { return __exportStar; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__values", function() { return __values; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__read", function() { return __read; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__spread", function() { return __spread; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__spreadArrays", function() { return __spreadArrays; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__await", function() { return __await; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__asyncGenerator", function() { return __asyncGenerator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__asyncDelegator", function() { return __asyncDelegator; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__asyncValues", function() { return __asyncValues; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__makeTemplateObject", function() { return __makeTemplateObject; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__importStar", function() { return __importStar; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "__importDefault", function() { return __importDefault; });
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    }
    return __assign.apply(this, arguments);
}

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __exportStar(m, exports) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}

function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result.default = mod;
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}


/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!***********************************!*\
  !*** (webpack)/buildin/global.js ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || new Function("return this")();
} catch (e) {
	// This works if the window reference is available
	if (typeof window === "object") g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),

/***/ "./node_modules/whatwg-fetch/fetch.js":
/*!********************************************!*\
  !*** ./node_modules/whatwg-fetch/fetch.js ***!
  \********************************************/
/*! exports provided: Headers, Request, Response, DOMException, fetch */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Headers", function() { return Headers; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Request", function() { return Request; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Response", function() { return Response; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DOMException", function() { return DOMException; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetch", function() { return fetch; });
var support = {
  searchParams: 'URLSearchParams' in self,
  iterable: 'Symbol' in self && 'iterator' in Symbol,
  blob:
    'FileReader' in self &&
    'Blob' in self &&
    (function() {
      try {
        new Blob()
        return true
      } catch (e) {
        return false
      }
    })(),
  formData: 'FormData' in self,
  arrayBuffer: 'ArrayBuffer' in self
}

function isDataView(obj) {
  return obj && DataView.prototype.isPrototypeOf(obj)
}

if (support.arrayBuffer) {
  var viewClasses = [
    '[object Int8Array]',
    '[object Uint8Array]',
    '[object Uint8ClampedArray]',
    '[object Int16Array]',
    '[object Uint16Array]',
    '[object Int32Array]',
    '[object Uint32Array]',
    '[object Float32Array]',
    '[object Float64Array]'
  ]

  var isArrayBufferView =
    ArrayBuffer.isView ||
    function(obj) {
      return obj && viewClasses.indexOf(Object.prototype.toString.call(obj)) > -1
    }
}

function normalizeName(name) {
  if (typeof name !== 'string') {
    name = String(name)
  }
  if (/[^a-z0-9\-#$%&'*+.^_`|~]/i.test(name)) {
    throw new TypeError('Invalid character in header field name')
  }
  return name.toLowerCase()
}

function normalizeValue(value) {
  if (typeof value !== 'string') {
    value = String(value)
  }
  return value
}

// Build a destructive iterator for the value list
function iteratorFor(items) {
  var iterator = {
    next: function() {
      var value = items.shift()
      return {done: value === undefined, value: value}
    }
  }

  if (support.iterable) {
    iterator[Symbol.iterator] = function() {
      return iterator
    }
  }

  return iterator
}

function Headers(headers) {
  this.map = {}

  if (headers instanceof Headers) {
    headers.forEach(function(value, name) {
      this.append(name, value)
    }, this)
  } else if (Array.isArray(headers)) {
    headers.forEach(function(header) {
      this.append(header[0], header[1])
    }, this)
  } else if (headers) {
    Object.getOwnPropertyNames(headers).forEach(function(name) {
      this.append(name, headers[name])
    }, this)
  }
}

Headers.prototype.append = function(name, value) {
  name = normalizeName(name)
  value = normalizeValue(value)
  var oldValue = this.map[name]
  this.map[name] = oldValue ? oldValue + ', ' + value : value
}

Headers.prototype['delete'] = function(name) {
  delete this.map[normalizeName(name)]
}

Headers.prototype.get = function(name) {
  name = normalizeName(name)
  return this.has(name) ? this.map[name] : null
}

Headers.prototype.has = function(name) {
  return this.map.hasOwnProperty(normalizeName(name))
}

Headers.prototype.set = function(name, value) {
  this.map[normalizeName(name)] = normalizeValue(value)
}

Headers.prototype.forEach = function(callback, thisArg) {
  for (var name in this.map) {
    if (this.map.hasOwnProperty(name)) {
      callback.call(thisArg, this.map[name], name, this)
    }
  }
}

Headers.prototype.keys = function() {
  var items = []
  this.forEach(function(value, name) {
    items.push(name)
  })
  return iteratorFor(items)
}

Headers.prototype.values = function() {
  var items = []
  this.forEach(function(value) {
    items.push(value)
  })
  return iteratorFor(items)
}

Headers.prototype.entries = function() {
  var items = []
  this.forEach(function(value, name) {
    items.push([name, value])
  })
  return iteratorFor(items)
}

if (support.iterable) {
  Headers.prototype[Symbol.iterator] = Headers.prototype.entries
}

function consumed(body) {
  if (body.bodyUsed) {
    return Promise.reject(new TypeError('Already read'))
  }
  body.bodyUsed = true
}

function fileReaderReady(reader) {
  return new Promise(function(resolve, reject) {
    reader.onload = function() {
      resolve(reader.result)
    }
    reader.onerror = function() {
      reject(reader.error)
    }
  })
}

function readBlobAsArrayBuffer(blob) {
  var reader = new FileReader()
  var promise = fileReaderReady(reader)
  reader.readAsArrayBuffer(blob)
  return promise
}

function readBlobAsText(blob) {
  var reader = new FileReader()
  var promise = fileReaderReady(reader)
  reader.readAsText(blob)
  return promise
}

function readArrayBufferAsText(buf) {
  var view = new Uint8Array(buf)
  var chars = new Array(view.length)

  for (var i = 0; i < view.length; i++) {
    chars[i] = String.fromCharCode(view[i])
  }
  return chars.join('')
}

function bufferClone(buf) {
  if (buf.slice) {
    return buf.slice(0)
  } else {
    var view = new Uint8Array(buf.byteLength)
    view.set(new Uint8Array(buf))
    return view.buffer
  }
}

function Body() {
  this.bodyUsed = false

  this._initBody = function(body) {
    this._bodyInit = body
    if (!body) {
      this._bodyText = ''
    } else if (typeof body === 'string') {
      this._bodyText = body
    } else if (support.blob && Blob.prototype.isPrototypeOf(body)) {
      this._bodyBlob = body
    } else if (support.formData && FormData.prototype.isPrototypeOf(body)) {
      this._bodyFormData = body
    } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
      this._bodyText = body.toString()
    } else if (support.arrayBuffer && support.blob && isDataView(body)) {
      this._bodyArrayBuffer = bufferClone(body.buffer)
      // IE 10-11 can't handle a DataView body.
      this._bodyInit = new Blob([this._bodyArrayBuffer])
    } else if (support.arrayBuffer && (ArrayBuffer.prototype.isPrototypeOf(body) || isArrayBufferView(body))) {
      this._bodyArrayBuffer = bufferClone(body)
    } else {
      this._bodyText = body = Object.prototype.toString.call(body)
    }

    if (!this.headers.get('content-type')) {
      if (typeof body === 'string') {
        this.headers.set('content-type', 'text/plain;charset=UTF-8')
      } else if (this._bodyBlob && this._bodyBlob.type) {
        this.headers.set('content-type', this._bodyBlob.type)
      } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
        this.headers.set('content-type', 'application/x-www-form-urlencoded;charset=UTF-8')
      }
    }
  }

  if (support.blob) {
    this.blob = function() {
      var rejected = consumed(this)
      if (rejected) {
        return rejected
      }

      if (this._bodyBlob) {
        return Promise.resolve(this._bodyBlob)
      } else if (this._bodyArrayBuffer) {
        return Promise.resolve(new Blob([this._bodyArrayBuffer]))
      } else if (this._bodyFormData) {
        throw new Error('could not read FormData body as blob')
      } else {
        return Promise.resolve(new Blob([this._bodyText]))
      }
    }

    this.arrayBuffer = function() {
      if (this._bodyArrayBuffer) {
        return consumed(this) || Promise.resolve(this._bodyArrayBuffer)
      } else {
        return this.blob().then(readBlobAsArrayBuffer)
      }
    }
  }

  this.text = function() {
    var rejected = consumed(this)
    if (rejected) {
      return rejected
    }

    if (this._bodyBlob) {
      return readBlobAsText(this._bodyBlob)
    } else if (this._bodyArrayBuffer) {
      return Promise.resolve(readArrayBufferAsText(this._bodyArrayBuffer))
    } else if (this._bodyFormData) {
      throw new Error('could not read FormData body as text')
    } else {
      return Promise.resolve(this._bodyText)
    }
  }

  if (support.formData) {
    this.formData = function() {
      return this.text().then(decode)
    }
  }

  this.json = function() {
    return this.text().then(JSON.parse)
  }

  return this
}

// HTTP methods whose capitalization should be normalized
var methods = ['DELETE', 'GET', 'HEAD', 'OPTIONS', 'POST', 'PUT']

function normalizeMethod(method) {
  var upcased = method.toUpperCase()
  return methods.indexOf(upcased) > -1 ? upcased : method
}

function Request(input, options) {
  options = options || {}
  var body = options.body

  if (input instanceof Request) {
    if (input.bodyUsed) {
      throw new TypeError('Already read')
    }
    this.url = input.url
    this.credentials = input.credentials
    if (!options.headers) {
      this.headers = new Headers(input.headers)
    }
    this.method = input.method
    this.mode = input.mode
    this.signal = input.signal
    if (!body && input._bodyInit != null) {
      body = input._bodyInit
      input.bodyUsed = true
    }
  } else {
    this.url = String(input)
  }

  this.credentials = options.credentials || this.credentials || 'same-origin'
  if (options.headers || !this.headers) {
    this.headers = new Headers(options.headers)
  }
  this.method = normalizeMethod(options.method || this.method || 'GET')
  this.mode = options.mode || this.mode || null
  this.signal = options.signal || this.signal
  this.referrer = null

  if ((this.method === 'GET' || this.method === 'HEAD') && body) {
    throw new TypeError('Body not allowed for GET or HEAD requests')
  }
  this._initBody(body)
}

Request.prototype.clone = function() {
  return new Request(this, {body: this._bodyInit})
}

function decode(body) {
  var form = new FormData()
  body
    .trim()
    .split('&')
    .forEach(function(bytes) {
      if (bytes) {
        var split = bytes.split('=')
        var name = split.shift().replace(/\+/g, ' ')
        var value = split.join('=').replace(/\+/g, ' ')
        form.append(decodeURIComponent(name), decodeURIComponent(value))
      }
    })
  return form
}

function parseHeaders(rawHeaders) {
  var headers = new Headers()
  // Replace instances of \r\n and \n followed by at least one space or horizontal tab with a space
  // https://tools.ietf.org/html/rfc7230#section-3.2
  var preProcessedHeaders = rawHeaders.replace(/\r?\n[\t ]+/g, ' ')
  preProcessedHeaders.split(/\r?\n/).forEach(function(line) {
    var parts = line.split(':')
    var key = parts.shift().trim()
    if (key) {
      var value = parts.join(':').trim()
      headers.append(key, value)
    }
  })
  return headers
}

Body.call(Request.prototype)

function Response(bodyInit, options) {
  if (!options) {
    options = {}
  }

  this.type = 'default'
  this.status = options.status === undefined ? 200 : options.status
  this.ok = this.status >= 200 && this.status < 300
  this.statusText = 'statusText' in options ? options.statusText : 'OK'
  this.headers = new Headers(options.headers)
  this.url = options.url || ''
  this._initBody(bodyInit)
}

Body.call(Response.prototype)

Response.prototype.clone = function() {
  return new Response(this._bodyInit, {
    status: this.status,
    statusText: this.statusText,
    headers: new Headers(this.headers),
    url: this.url
  })
}

Response.error = function() {
  var response = new Response(null, {status: 0, statusText: ''})
  response.type = 'error'
  return response
}

var redirectStatuses = [301, 302, 303, 307, 308]

Response.redirect = function(url, status) {
  if (redirectStatuses.indexOf(status) === -1) {
    throw new RangeError('Invalid status code')
  }

  return new Response(null, {status: status, headers: {location: url}})
}

var DOMException = self.DOMException
try {
  new DOMException()
} catch (err) {
  DOMException = function(message, name) {
    this.message = message
    this.name = name
    var error = Error(message)
    this.stack = error.stack
  }
  DOMException.prototype = Object.create(Error.prototype)
  DOMException.prototype.constructor = DOMException
}

function fetch(input, init) {
  return new Promise(function(resolve, reject) {
    var request = new Request(input, init)

    if (request.signal && request.signal.aborted) {
      return reject(new DOMException('Aborted', 'AbortError'))
    }

    var xhr = new XMLHttpRequest()

    function abortXhr() {
      xhr.abort()
    }

    xhr.onload = function() {
      var options = {
        status: xhr.status,
        statusText: xhr.statusText,
        headers: parseHeaders(xhr.getAllResponseHeaders() || '')
      }
      options.url = 'responseURL' in xhr ? xhr.responseURL : options.headers.get('X-Request-URL')
      var body = 'response' in xhr ? xhr.response : xhr.responseText
      resolve(new Response(body, options))
    }

    xhr.onerror = function() {
      reject(new TypeError('Network request failed'))
    }

    xhr.ontimeout = function() {
      reject(new TypeError('Network request failed'))
    }

    xhr.onabort = function() {
      reject(new DOMException('Aborted', 'AbortError'))
    }

    xhr.open(request.method, request.url, true)

    if (request.credentials === 'include') {
      xhr.withCredentials = true
    } else if (request.credentials === 'omit') {
      xhr.withCredentials = false
    }

    if ('responseType' in xhr && support.blob) {
      xhr.responseType = 'blob'
    }

    request.headers.forEach(function(value, name) {
      xhr.setRequestHeader(name, value)
    })

    if (request.signal) {
      request.signal.addEventListener('abort', abortXhr)

      xhr.onreadystatechange = function() {
        // DONE (success or failure)
        if (xhr.readyState === 4) {
          request.signal.removeEventListener('abort', abortXhr)
        }
      }
    }

    xhr.send(typeof request._bodyInit === 'undefined' ? null : request._bodyInit)
  })
}

fetch.polyfill = true

if (!self.fetch) {
  self.fetch = fetch
  self.Headers = Headers
  self.Request = Request
  self.Response = Response
}


/***/ })

/******/ });
});
//# sourceMappingURL=okuna.map